#include <malloc.h>
#include <stdio.h>
#include <string.h>

#include <isode/quipu/name.h>
#include <isode/quipu/util.h>
#include <isode/quipu/modify.h>
#include <isode/quipu/ds_error.h>

#include "addremovemodrdn.h"
#include "algoname.h"
#include "bulkloadattrnames.h"
#include "bulkloadglobal.h"
#include "configuration.h"
#include "modify.h"
#include "namelist.h"
#include "processandupdate.h"
#include "processbulkandupdatedir.h"
#include "subdirectory.h"
#include "util.h"


extern	struct	bulkLoadConfigStruct bulkLoadConfig ;




void
transferAttribute( OFD, outFileType, attrLinecp, message1cp, message2cp )
struct	outputFileDetails OFD[] ;
int	outFileType ;
char *	attrLinecp, * message1cp, * message2cp ;
{
FILE * 	outFilep = OFD[ outFileType ].outFilep ;

	if( OFD[ outFileType ].RootedAtOutput == FALSE )
	{
	    if( outFileType == OUTPUTDRAFTFILE )
	    {
	    	fprintf( outFilep, "# Attribute update rootedAt : %s", OFD[ outFileType ].RootedAtDNcp ) ;
		if( OFD[ outFileType ].SubDirListResolvedParentDNcp != NULLCP )
		    fprintf( outFilep, "\n# DN : %s", OFD[ outFileType ].SubDirListResolvedParentDNcp ) ;
	    }
	    else
	    {
	    	fprintf( outFilep, "\n%s%s", ROOTEDATHEAD, OFD[ outFileType ].RootedAtDNcp ) ;
		if( OFD[ outFileType ].SubDirListResolvedParentDNcp != NULLCP )
		    fprintf( outFilep, "\n# DN : %s", OFD[ outFileType ].SubDirListResolvedParentDNcp ) ;

		fprintf( outFilep, "\n\n" ) ;
	    }

	    OFD[ outFileType ].RootedAtOutput = TRUE ;
	}
	
	if( OFD[ outFileType ].RDNoutput == FALSE )
	{
	    if( outFileType == OUTPUTDRAFTFILE )
	    	fprintf( outFilep, "\n# Attribute update for RDN  : %s", OFD[ outFileType ].rdnLinecp ) ;
	    else
	    	fprintf( outFilep, "\n%s", OFD[ outFileType ].rdnLinecp ) ;

	    OFD[ outFileType ].RDNoutput = TRUE ;
	}
	
	if( message1cp != NULLCP )
	    fprintf( outFilep, "# %s...\n", message1cp ) ;

	if( message2cp != NULLCP )
	    fprintf( outFilep, "# %s...\n", message2cp ) ;

	if( attrLinecp != NULLCP )
	    fprintf( outFilep, "%s", attrLinecp ) ;

	return ;

} /* transferAttribute() */


void
transferRDNattrs( OFD, outFileType, baseALp, message1cp, message2cp )
struct	outputFileDetails OFD[] ;
int	outFileType ;
struct	attributeLine 	   * baseALp ;
char *	message1cp, *message2cp ;
{
struct	attributeLine 	   * currALp = baseALp ;
FILE * 	outFilep = OFD[ outFileType ].outFilep ;

	if( OFD[ outFileType ].RootedAtOutput == FALSE )
	{
	    if( outFileType == OUTPUTDRAFTFILE )
	    {
	    	fprintf( outFilep, "# Attribute update rootedAt : %s", OFD[ outFileType ].RootedAtDNcp) ;
		if( OFD[ outFileType ].SubDirListResolvedParentDNcp != NULLCP )
		    fprintf( outFilep, "\n# DN : %s", OFD[ outFileType ].SubDirListResolvedParentDNcp ) ;
	    }
	    else
	    {
	    	fprintf( outFilep, "\n%s%s\n", ROOTEDATHEAD, OFD[ outFileType ].RootedAtDNcp ) ;
		if( OFD[ outFileType ].SubDirListResolvedParentDNcp != NULLCP )
		    fprintf( outFilep, "# DN : %s", OFD[ outFileType ].SubDirListResolvedParentDNcp ) ;

		fprintf( outFilep, "\n\n" ) ;
	    }

	    OFD[ outFileType ].RootedAtOutput = TRUE ;
	}
	
	if( OFD[ outFileType ].RDNoutput == FALSE )
	{
	    if( outFileType == OUTPUTDRAFTFILE )
	    	fprintf( outFilep, "\n# Attribute update for RDN  : %s", OFD[ outFileType ].rdnLinecp ) ;
	    else
	    	fprintf( outFilep, "\n%s", OFD[ outFileType ].rdnLinecp ) ;

	    OFD[ outFileType ].RDNoutput = TRUE ;
	}
	
	if( message1cp != NULLCP )
	    fprintf( outFilep, "# %s\n# %s...\n", message1cp, (message2cp != NULLCP) ? message2cp : "" ) ;

	/* Run through the attributes.. */
	while( currALp != NULLALP )
	{
	    if( currALp -> attrUsed == FALSE )
	    {
		if( currALp -> errorMsgcp != NULLCP )
		    fprintf( outFilep, "# %s\n", currALp -> errorMsgcp ) ;

	    	fprintf( outFilep, "%s", currALp -> attrLinecp ) ;
	    }
	    	
	    currALp = currALp -> nextAttrLinep ;
	}

	return ;

} /* transferRDNattrs() */


/*
 * Note: the attribute lines would then be output (after processing)
 * by transferRDNattrs() or transferAttribute().
 */

void
transferRootedAtModRDN( OFD, outFileType, currRAAp, message1cp, message2cp )
struct	outputFileDetails OFD[] ;
int	outFileType ;
struct	rootedAtAttributes * currRAAp ;
char *	message1cp, * message2cp ;
{
FILE * 	outFilep = OFD[ outFileType ].outFilep ;
char *	rdncp ;

	if( OFD[ outFileType ].RootedAtOutput == FALSE )
	{
	    fprintf( outFilep, "\n%s%s\n", ROOTEDATHEAD, OFD[ outFileType ].RootedAtDNcp ) ;
	    if( OFD[ outFileType ].SubDirListResolvedParentDNcp != NULLCP )
		fprintf( outFilep, "# DN : %s\n", OFD[ outFileType ].SubDirListResolvedParentDNcp ) ;

	    OFD[ outFileType ].RootedAtOutput = TRUE ;
	}
	
	if( OFD[ outFileType ].RDNoutput == FALSE )
	{
	    fprintf( outFilep, "\n%s", OFD[ outFileType ].rdnLinecp ) ;

	    OFD[ outFileType ].RDNoutput = TRUE ;
	}
	
	if( currRAAp )
	{
	    if( message1cp != NULLCP )
	    	fprintf( outFilep, "# %s\n# %s...\n", message1cp, (message2cp != NULLCP) ? message2cp : "" ) ;

	    if( currRAAp -> modRdn != NULLRDN &&
	       (rdncp = rdn2pstr( currRAAp -> modRdn)) != NULLCP )
	    {	
		fprintf( outFilep, "%c%s\n", MODRDNCHAR, rdncp ) ;
		free( rdncp ) ;
	    }
	}

	return ;

}

void
transferRootedAtRDNattrs( OFD, outFileType, currRAAp, message1cp, message2cp )
struct	outputFileDetails OFD[] ;
struct	rootedAtAttributes * currRAAp ;
char *	message1cp, * message2cp ;
{
struct	attributeLine 	   * currALp ;
FILE * 	outFilep = OFD[ outFileType ].outFilep ;
char *	rdncp ;

	if( OFD[ outFileType ].RootedAtOutput == FALSE )
	{
	    fprintf( outFilep, "\n%s%s\n", ROOTEDATHEAD, OFD[ outFileType ].RootedAtDNcp ) ;
	    if( OFD[ outFileType ].SubDirListResolvedParentDNcp != NULLCP )
		fprintf( outFilep, "# DN : %s\n", OFD[ outFileType ].SubDirListResolvedParentDNcp ) ;
	    OFD[ outFileType ].RootedAtOutput = TRUE ;
	}

	if( message1cp != NULLCP )
	    fprintf( outFilep, "\n# %s\n# %s...\n", message1cp, (message2cp != NULLCP) ? message2cp : "" ) ;

	if( OFD[ outFileType ].RDNoutput == FALSE )
	{
	    fprintf( outFilep, "\n%s", OFD[ outFileType ].rdnLinecp ) ;

	    OFD[ outFileType ].RDNoutput = TRUE ;
	}

	if( currRAAp -> modRdn != NULLRDN &&
	    (rdncp = rdn2pstr( currRAAp -> modRdn)) != NULLCP )
	{	
	    fprintf( outFilep, "%c%s\n", MODRDNCHAR, rdncp ) ;
	    free( rdncp ) ;
	}
	    
	currALp = currRAAp -> attrLinep ;

	while( currALp )
	{
	    if( currALp -> attrUsed == FALSE )
	    {
		if( currALp -> errorMsgcp != NULLCP )
		    fprintf( outFilep, "# %s\n", currALp -> errorMsgcp ) ;

	    	fprintf( outFilep, "%s", currALp -> attrLinecp ) ;
	    }
	    	
	    currALp = currALp -> nextAttrLinep ;
	}

	return ;
}

/*
 * For "dmformat" initialisation files all updates are additions,
 * so the only work required is to determine whether the current
 * attribute is being loaded for the first time.
 *
 * For "newdmdiff" output files the leading character indicates
 * the action to be taken.
 *
 * RDN modifications are handled directly from the "rootedAtAttributes" structure "modRdn" pointer.
 *
 * Note: if the "-e" option is used we should be updating existing entries
 */

int
determineActionReq( lineBufferp, actionReqp, inFileType, isRDN, currAttrLinep, updatesToExistingEntries )
char *	lineBufferp ;
int  *	actionReqp ;
int	inFileType, isRDN ;
struct	attributeLine * currAttrLinep ; /* NULL if isRDN == TRUE */
int	updatesToExistingEntries ;
{
int	ret_val = OK ;
char	leadChar = *lineBufferp ;

#ifdef DEBUG
if( inFileType == DMFORMATFILEINPUT )
	fprintf( stderr, "			DMFORMAT FILE BEING PROCESSED \n" ) ;
else
	fprintf( stderr, "			NEWDMFORMAT FILE BEING PROCESSED \n" ) ;
#endif

	if( inFileType == DMFORMATFILEINPUT )
	{
	    /* Note: file type indicates all updates are additions */

	    if( isRDN == TRUE )
	    {
		if( updatesToExistingEntries == TRUE )
	    	    *actionReqp = NOACTIONREQ ;
		else
	    	    *actionReqp = ADDRDNACTION ;
	    }
	    else if( currAttrLinep -> nthAttrOfThisType == 1 )
	   	     *actionReqp = ADDATTRACTION ;
		 else
	    	     *actionReqp = ADDVALUEACTION ;
	}
	else
	{
	    /* NEWDMDIFFINPUT */

	    switch( leadChar )
	    {
		case ADDRDNCHAR :
			if( updatesToExistingEntries == TRUE )
	    		    *actionReqp = NOACTIONREQ ;
			else
			    *actionReqp = ADDRDNACTION ;
			break;
		case DELETERDNCHAR :
			*actionReqp = DELETERDNACTION ;
			break ;
		case ADDATTRCHAR :
			*actionReqp = ADDATTRACTION ;
			break ;
		case DELETEATTRCHAR :
			*actionReqp = DELETEATTRACTION ;
			break ;
		case ADDVALUECHAR :
			*actionReqp = ADDVALUEACTION ;
			break ;
		case DELETEVALUECHAR :
			*actionReqp = DELETEVALUEACTION ;
			break ;
			
		default : /* Should be an RDN for an existing entry
		             e.g. cn=Paul Barker		  */
			if( isRDN == TRUE )
			{
			    *actionReqp = NOACTIONREQ ; /* No action required given the RDN line
			    				   though there may be RDN modification or
							   attribute updates still to be processed */
			}
			else ret_val = NOTOK ;

			break ;
	    }
	}

	return( ret_val ) ; /* OK or NOTOK */

} /* determineActionReq() */

int
bulkDataObjClsPresent( baseas )
Attr_Sequence 	baseas ;
{
int	objClsFound = FALSE, bulkObjClsFound = FALSE ;
Attr_Sequence 	curras  ;
AV_Sequence	avs ;
static	AttributeType  objClsat = NULLAttrT ;
static	AttributeValue dataEntryObjClsav = NULLAttrV, dataSourceObjClsav = NULLAttrV, 
		       dataSourceEntryObjClsav = NULLAttrV, bulkSubDirListObjClsav = NULLAttrV ;

	if( objClsat == NULLAttrT )
	{
	    objClsat = str2AttrT( BL_OBJECT_CLASS ) ;
	}

	if( dataEntryObjClsav == NULLAttrV )
	{
	    dataEntryObjClsav = str2AttrV( BL_BULK_DATA_ENTRY_DETAILS, objClsat->oa_syntax ) ;
	}

	if( dataSourceObjClsav == NULLAttrV )
	{
	    dataSourceObjClsav = str2AttrV( BL_BULK_DATA_SOURCE_DETAILS, objClsat->oa_syntax ) ;
	}

	if( dataSourceEntryObjClsav == NULLAttrV )
	{
	    dataSourceEntryObjClsav = str2AttrV( BL_BULK_DATA_SOURCE_ENTRY, objClsat->oa_syntax ) ;
	}

	if( bulkSubDirListObjClsav == NULLAttrV )
	{
	    bulkSubDirListObjClsav = str2AttrV( BL_BULK_SUB_DIR_LIST_CLASS, objClsat->oa_syntax ) ;
	}

	/* For the objectClass and algoName attribute sequences.. */
	for( curras = baseas ;  objClsFound == FALSE && curras != NULLATTR ; curras = curras -> attr_link )
	{
	    if( AttrT_cmp( curras->attr_type, objClsat ) == 0 )
	    {
		objClsFound = TRUE ;
	    
		/* Run through the "objectClass" values */
		for( avs = curras -> attr_value ; bulkObjClsFound == FALSE && avs != NULLAV ; avs = avs -> avseq_next )
		{
		    if( AttrV_cmp( &(avs->avseq_av), dataSourceEntryObjClsav ) == 0 ||
			AttrV_cmp( &(avs->avseq_av), dataSourceObjClsav )      == 0 ||
			AttrV_cmp( &(avs->avseq_av), dataEntryObjClsav )       == 0 ||
			AttrV_cmp( &(avs->avseq_av), bulkSubDirListObjClsav )  == 0   )
		    {
			bulkObjClsFound = TRUE ;
		    }
		}
	    }
	}

	return( bulkObjClsFound ) ;
}

#define BIGBUFFERSIZE	10000

Attr_Sequence
formAttrSeqFromRAA( currRAAp )
struct	rootedAtAttributes * currRAAp ;
{
struct	attributeLine 	   * currAttrLinep ;
Attr_Sequence 	baseas = NULLATTR, newas = NULLATTR ;
AV_Sequence	baseavs= NULLAV  , newavs=NULLAV ;
AttributeType 	lastAt = NULLAttrT ;
AttributeValue 	av ;
static	AttributeType aclat = NULLAttrT ;
char	aclBuildAVSbuffer[ BIGBUFFERSIZE ], *currAclBuildcp = aclBuildAVSbuffer, *avcp, *equalscp ;

	if( aclat == NULLAttrT )
	    aclat =  str2AttrT( BL_ACCESS_CONTROL_LIST ) ;

	currAttrLinep = currRAAp -> attrLinep ;

	while( currAttrLinep )
	{
	    if( lastAt == NULLAttrT || AttrT_cmp( currAttrLinep -> at, lastAt ) == 0 )
	    {
		if( aclat != NULLAttrT &&
		    AttrT_cmp( currAttrLinep -> at, aclat ) == 0 )
		{
		    aclBuildAVSbuffer[0] = '\0' ;
		    
		    /* ACL attribute must be handled in a special way due to its defaults.. */

		    while( currAttrLinep && AttrT_cmp( currAttrLinep -> at, aclat ) == 0 )
		    {
			if( (avcp = strDupTidyStringRemLineConts( currAttrLinep -> attrLinecp )) != NULLCP )
		    	{
			    if( (equalscp = strchr( avcp, '=' )) != NULLCP )
			    {
				sprintf( currAclBuildcp, "%s &", equalscp+1 ) ; /* Skipping the "acl=" */
				currAclBuildcp = currAclBuildcp + strlen( equalscp+1 ) + 2 ;
			    }

			    free( avcp ) ;
			}

		    	currAttrLinep = currAttrLinep -> nextAttrLinep ;
		    }

		    if( currAclBuildcp > aclBuildAVSbuffer )
		    {
		    	if( *(currAclBuildcp-1) == '&' )
			{
			    *(currAclBuildcp-1) = '#' ;
			    
		    	    baseavs = str2avs( aclBuildAVSbuffer, aclat ) ;
			}
		    }
		    
		    if( lastAt == NULLAttrT )
			lastAt = AttrT_cpy( aclat ) ;
		}
		else
		{
		    /* Append the current AV into the AV_Sequence.. */

		    av = AttrV_cpy( currAttrLinep -> av ) ;

		    if( av != NULLAttrV )
		    {
		    	newavs = avs_comp_new( av ) ;

		    	if( baseavs != NULLAV )
		    	    baseavs = avs_merge( baseavs, newavs ) ;
		    	else
		    	    baseavs = newavs ;
			   
		    }

		    if( lastAt == NULLAttrT )
		    	lastAt = AttrT_cpy( currAttrLinep -> at ) ;

		    currAttrLinep = currAttrLinep -> nextAttrLinep ;
		}
	    }
	    else
	    {
	    	/* Add in the completed AVS to the Attr_Sequence.. */
		
	    	if( baseavs != NULLAV && lastAt != NULLAttrT )
		{
	    	    newas = as_comp_new( lastAt, baseavs, NULLACL_INFO );

		    if( baseas != NULLATTR )
		    	baseas = as_merge( baseas, newas ) ;
		    else
		    	baseas = newas ;
		}

		baseavs = NULLAV ;

		if( lastAt != NULLAttrT )
		    AttrT_free( lastAT ) ;

		lastAt = AttrT_cpy( currAttrLinep -> at ) ;

	    	/* Note: the currAttrLinep will now be used in the first 'if' block */
	    }
	}
	

	/* Merge any remaing AV_Sequence.. */
	if( baseavs != NULLAV && lastAt != NULLAttrT )
	{
	    newas = as_comp_new( lastAt, baseavs, NULLACL_INFO );

	    if( baseas != NULLATTR )
		baseas = as_merge( baseas, newas ) ;
	    else
		baseas = newas ;
	}

	if( lastAt != NULLAttrT )
	    AttrT_free( lastAt ) ;

	return( baseas ) ;
}


/* 
 * Determine the file output or interactive processing requirements that have been configured
 * for the error (if any)..
 */
 
void
checkForSendToFileReq( isMasterSource, em_type, errorClass, errorType, procReq )
int	isMasterSource, em_type, errorClass, errorType, *procReq ;
{
	*procReq = PROCESSTHEUPDATE ;


	if( em_type == EM_ADDATTRIBUTE )
	{
	    if( errorClass == DSE_ATTRIBUTEERROR && errorType == DSE_AT_TYPEORVALUEEXISTS )
	        *procReq = bulkLoadConfig.configErrorProcReq[ ADDATTRIBUTETHATALREADYEXISTS ] ;

	    else if( isMasterSource == FALSE )
	        *procReq = bulkLoadConfig.configErrorProcReq[ ADDATTRIBUTEWHENNOTMASTERSOURCE ] ;
	    
	}
	else if( em_type == EM_ADDVALUES )
	{
	    if( errorClass == DSE_ATTRIBUTEERROR && errorType == DSE_AT_TYPEORVALUEEXISTS )
	    	*procReq = bulkLoadConfig.configErrorProcReq[ ADDVALUETHATALREADYEXISTS ] ;

	    else if( isMasterSource == FALSE )
	        *procReq = bulkLoadConfig.configErrorProcReq[ ADDVALUEWHENNOTMASTERSOURCE ] ;
	}
	else if( em_type    == EM_REMOVEATTRIBUTE && 
	     	 errorClass == DSE_ATTRIBUTEERROR && errorType == DSE_AT_NOSUCHATTRIBUTE )
	{
	    *procReq = bulkLoadConfig.configErrorProcReq[ DELETEATTRIBUTETHATDOESNOTEXIST ] ;
	}
	else if( em_type    == EM_REMOVEVALUES && 
		 errorClass == DSE_ATTRIBUTEERROR && errorType == DSE_AT_NOSUCHATTRIBUTE )
	{
	    *procReq = bulkLoadConfig.configErrorProcReq[ DELETEVALUETHATDOESNOTEXIST ] ;
	}
	    
	return ;
}


/*
 * Check if the attribute type to be cleared down has any values currently.
 */

int
removeRequestLikelyToSucceed( entryAS, at )
Attr_Sequence	entryAS ;
AttributeType	at ;
{
int	attrTypeHasValuesListed = FALSE ;
Attr_Sequence currats ;

	for( currats = entryAS ; currats != NULLATTR ; currats = currats -> attr_link )
 	{
	    if( AttrT_cmp( currats -> attr_type, at ) == 0 && currats -> attr_value != NULLAV )
	    {
		attrTypeHasValuesListed = TRUE ;
		break ;
	    }
	}

	return( attrTypeHasValuesListed ) ;
}

/*
 * Perform a read operation to retrieve the current values of "acl", "objectClass" and
 * "nonMasterUpdatedAttrType" from the entry to be updated.
 *
 * Perform a check that each  attribute having its type held in the "nonMasterUpdatedAttrType"
 * attribute holds a value, else clear down the corresponding "nonMasterUpdatedAttrType" value.
 */
 
void
readObjClsACLNonMasterUpAttrAndOtherAttrsAndCorrectDirectory( entryDN, aclAVSfromEntryp, objClsAVSfromEntryp, nonMasterUpAttrAVSfromEntryp, otherAttrsASfromEntryp )
DN	entryDN ;
AV_Sequence 	* aclAVSfromEntryp, * objClsAVSfromEntryp, * nonMasterUpAttrAVSfromEntryp ;
Attr_Sequence	* otherAttrsASfromEntryp ;
{
Attr_Sequence currats ;
AV_Sequence   nonMasterUpAvs, prevNonMasterUpAvs ;
AttributeType at ;
struct  namelist * resultListp = NULLLIST ;
static	AttributeType  nonMasterUpAtat = NULLAttrT, aclat = NULLAttrT, objClsat = NULLAttrT ;
struct	entrymod * baseModNodep = NULLMOD, * currModNodep = NULLMOD ;
struct 	DSError	 * dserrorp ;
int	nonMasterUpAtRetrieved = FALSE, thisMasterUpAtValueValid, numOfMasterUpAtValues=0, numOfMasterUpAtDelValues=0 ;
char *	avcp ;

	if( objClsat == NULLAttrT )
	    objClsat =  str2AttrT( BL_OBJECT_CLASS ) ;

	if( aclat == NULLAttrT )
	    aclat = str2AttrT( BL_ACCESS_CONTROL_LIST ) ;

	if( nonMasterUpAtat == NULLAttrT )
	    nonMasterUpAtat =  str2AttrT( BL_NON_MASTER_UPDATED_ATTR_TYPE ) ;

	if( *nonMasterUpAttrAVSfromEntryp != NULLAV )
	{
	    avs_free( *nonMasterUpAttrAVSfromEntryp ) ;
	    *nonMasterUpAttrAVSfromEntryp = NULLAV ;
	}

	/* Perform the entry read.. */
	if( readEntry( entryDN, &resultListp, NULLLIST, TRUE ) == OK )
	{
	    if( resultListp != NULLLIST )
	    {		
		for( currats = resultListp -> ats ; currats != NULLATTR ; currats = currats -> attr_link )
 		{
		    if( aclat != NULLAttrT &&
		    	AttrT_cmp( currats -> attr_type, aclat ) == 0 &&
		    	currats -> attr_value != NULLAV )
		    {
			/* Assign the returned attribute sequence to the returned attribute sequence.. */
			*aclAVSfromEntryp = currats -> attr_value ;

			/* Ensure that we do not free the sequence storage.. */
			currats -> attr_value = NULLAV ;			    
		    }		
		    else if( AttrT_cmp( currats -> attr_type, objClsat ) == 0 &&
		    	currats -> attr_value != NULLAV )
		    {
			/* Assign the returned attribute sequence to the returned attribute sequence.. */
			*objClsAVSfromEntryp = currats -> attr_value ;

			/* Ensure that we do not free the sequence storage.. */
			currats -> attr_value = NULLAV ;			    
		    }		
		    else if( AttrT_cmp( currats -> attr_type, nonMasterUpAtat ) == 0 &&
			currats -> attr_value != NULLAV )
		    {
			/* Assign the returned attribute sequence to the returned attribute sequence.. */
			*nonMasterUpAttrAVSfromEntryp = currats -> attr_value ;

			nonMasterUpAtRetrieved = TRUE ;

			/* Ensure that we do not free the sequence storage.. */
			currats -> attr_value = NULLAV ;			    
		    }
	    	}

		if( nonMasterUpAtRetrieved == TRUE && *nonMasterUpAttrAVSfromEntryp != NULLAV )
		{
		    /* Run through the original "nonMasterUpdatedAttrType" values */

		    prevNonMasterUpAvs = NULLAV ;

		    nonMasterUpAvs = *nonMasterUpAttrAVSfromEntryp ;

		    numOfMasterUpAtValues = 0 ; numOfMasterUpAtDelValues = 0 ;

		    while( nonMasterUpAvs != NULLAV )
		    {
			thisMasterUpAtValueValid = TRUE ;
				
			if( (avcp = AttrV2pstr( &(nonMasterUpAvs -> avseq_av) )) != NULLCP )
			{
			    numOfMasterUpAtValues++ ;
			    
			    if( (at = str2AttrT( avcp )) != NULLAttrT )
			    {
				thisMasterUpAtValueValid = FALSE ;
					
				for( currats = resultListp -> ats ; currats != NULLATTR ; currats = currats -> attr_link )
				{
		    		    if( AttrT_cmp( currats -> attr_type, at ) == 0 )
				    {
					thisMasterUpAtValueValid = TRUE ;
					break ;
				    }
				}

				AttrT_free( at ) ;
			    }
				    
			    free( avcp ) ;
		    	}

			if( thisMasterUpAtValueValid == FALSE )
			{
			    /* Add the "nonMasterUpdatedAttrType" value to the list for removal.. */
			    currModNodep = create_attr_mod( EM_REMOVEVALUES, nonMasterUpAtat, &(nonMasterUpAvs -> avseq_av) ) ;

			    append_attr_mod( &baseModNodep, currModNodep ) ;

			    numOfMasterUpAtDelValues++ ;

			    /* Remove the value from the "nonMasterUpdatedAttrType" cache */
			    if( prevNonMasterUpAvs == NULLAV )
				*nonMasterUpAttrAVSfromEntryp = nonMasterUpAvs -> avseq_next ;
			    else
				prevNonMasterUpAvs -> avseq_next = nonMasterUpAvs -> avseq_next ;
									    	
			    /* And free the nodes storage.. */
			    nonMasterUpAvs -> avseq_next = NULLAV ;
			    avs_free( nonMasterUpAvs ) ;

			    if( prevNonMasterUpAvs == NULLAV )
				nonMasterUpAvs = *nonMasterUpAttrAVSfromEntryp ;
			    else
				nonMasterUpAvs = prevNonMasterUpAvs -> avseq_next ;
			}
			else
			{
			    prevNonMasterUpAvs = nonMasterUpAvs ;
			    nonMasterUpAvs = nonMasterUpAvs -> avseq_next ;
			}

		    } /* while loop */

		    if( numOfMasterUpAtValues > 0 && numOfMasterUpAtValues == numOfMasterUpAtDelValues )
		    {
			/* We are removing all of the values so replace with a
			   REMOVE ATTRIBUTE operation.. */
			       
			free_attr_mod_list( baseModNodep ) ; baseModNodep = NULLMOD ;

			currModNodep = create_attr_mod( EM_REMOVEATTRIBUTE, nonMasterUpAtat, NULLAttrV ) ;

			append_attr_mod( &baseModNodep, currModNodep ) ;
		    }

		    /* Apply any updates to the nonMasterUpdatedAttrType attribute.. */
		    if( baseModNodep != NULLMOD )
		    {			
			if( modifyDirectory( baseModNodep, entryDN, &dserrorp ) != OK )
			    ds_error_free( dserrorp ) ;

			free_attr_mod_list( baseModNodep ) ;
		    }
		}

	    	*otherAttrsASfromEntryp = resultListp -> ats ;
		resultListp -> ats = NULLATTR ; /* To prevent the storage being returned here */

		/* Now free the remaining results storage.. */
		freeListpp( &resultListp ) ;
	    }
	}
	
	return ;
}



/* 
 * Given an attribute line list set up the "attrIsMasteredByCurrentSource" fields.
 */

void
setUpTheMasterAttrLineDetails( baseDataSourceLevelp, baseALp, sourceNamecp )
struct 	dataSourceLevel * baseDataSourceLevelp ;
struct	attributeLine   * baseALp ;
char *	sourceNamecp ;
{
struct	attributeLine   * currALp = baseALp, * prevALp = NULLALP ;
int 	isMastered = FALSE ;

	while( currALp != NULLALP )
	{
	    if( prevALp != NULLALP &&
	    	AttrT_cmp( currALp -> at, prevALp -> at ) == 0 )
	    {
		/* Same attribute type so same mastering.. */
		currALp -> attrIsMasteredByCurrentSource = isMastered ;		    
	    }
	    else
	    {
	    	isMastered = currALp -> attrIsMasteredByCurrentSource =
			sourceIsMasterOfAttrT( baseDataSourceLevelp, sourceNamecp, currALp -> at ) ;
	    }

	    prevALp = currALp ;
	    currALp = currALp -> nextAttrLinep ;
	}

	return ;
}

/*
 * When an entry is being added check the master sources in force so that
 * the "nonMasterUpdatedAttrType" values can be set up correctly.
 *
 * A new Attr_Sequence structure will be inserted at the beginning of the 
 * sequence received.
 */
void
appendNonMasterUpdatesForNewEntry( baseDataSourceLevelp, sourceNamecp, asp )
struct 	dataSourceLevel * baseDataSourceLevelp ;
char *	sourceNamecp ;
Attr_Sequence *	asp ; /* Sequence already contains a list of attribute that are to be added */
{
static		AttributeType nonMasterUpAt = NULLAttrT ;
AttributeType	prevat = NULLAttrT ;
AttributeValue	nonMasterUpAv ;
AV_Sequence	nonMasterUpavs, buffavs ;
Attr_Sequence	curras, nonMasterUpas = NULLATTR, buffas ;
char *	atcp ;

	if( nonMasterUpAt == NULLAttrT )
	    nonMasterUpAt =  str2AttrT( BL_NON_MASTER_UPDATED_ATTR_TYPE ) ;

	if( baseDataSourceLevelp != NULLSOURCELEVEL && asp && (*asp) != NULLATTR && nonMasterUpAt != NULLAttrT )
	{
	    /* Run through the attribute types listed for entry addition so far.. */

	    curras = *asp ;

	    while( curras != NULLATTR )
	    {
	    	if( prevat == NULLAttrT ||
		    AttrT_cmp( curras -> attr_type, prevat ) != 0 )
	    	{
		    if( sourceIsMasterOfAttrT( baseDataSourceLevelp, sourceNamecp, curras -> attr_type ) == FALSE )
		    {
			nonMasterUpAv = NULLAttrV ;
		    
		    	if( (atcp = AttrT2pstr( curras -> attr_type )) != NULLCP &&
			    (nonMasterUpAv = str2AttrV( atcp, nonMasterUpAt -> oa_syntax )) != NULLAttrV )
			{
	 		    /* Type must be added.. */
			    if( nonMasterUpas == NULLATTR )
			    {
			    	/* First value to be added so insert a new Attr_Sequence node.. */
			    	if( (nonMasterUpas = as_comp_new( nonMasterUpAt, avs_comp_new( nonMasterUpAv ), NULLACL_INFO )) != NULLATTR )
			    	{
				    buffas = *asp, *asp = nonMasterUpas ;
				
			    	    *asp = nonMasterUpas ;

				    /* link in to the sequence.. */
				    nonMasterUpas -> attr_link = buffas ;
				}
			    }
			    else 
			    {
	    		    	if( (nonMasterUpavs = avs_comp_new( nonMasterUpAv )) != NULLAV )
				{
			    	    /* Insert the attribute value in AV Sequence.. */
			    	    buffavs = nonMasterUpas -> attr_value ;

				    nonMasterUpas -> attr_value = nonMasterUpavs ;
				
				    /* link in to the sequence.. */
				    nonMasterUpavs -> avseq_next = buffavs ;
				}
			    }
			}		    	

			if( atcp != NULLCP ) free( atcp ) ;
		    }
		}

		prevat = curras -> attr_type ;

		curras = curras -> attr_link ;
	    }
	}

	return ;
}

/*
 * Check the "nonMasterUpdatedAttrType" attribute for the entry to 
 * determine whether the specified attribute type has already been
 * updated by a non master source. 
 */

int
hasAttrBeenLoadedByAnonMaster( nonMasterUpAttrAVSfromEntryp, at )
AV_Sequence * 	nonMasterUpAttrAVSfromEntryp ;
AttributeType	at ;
{
int		hasAttrBeenLoadedByAnonMasterSource = FALSE ;
AV_Sequence	avs ;
AttributeValue  nonMasterUpAv = NULLAttrV ;
char *		nonMasterUpValuecp = NULLCP ;

static	AttributeType nonMasterUpAt = NULLAttrT ;

	if( nonMasterUpAt == NULLAttrT )
	    nonMasterUpAt =  str2AttrT( BL_NON_MASTER_UPDATED_ATTR_TYPE ) ;

	if((nonMasterUpAt != NULLAttrT ) &&
	   (nonMasterUpValuecp = AttrT2pstr( at )) != NULLCP &&
	   (nonMasterUpAv      = str2AttrV(  nonMasterUpValuecp, nonMasterUpAt -> oa_syntax )) != NULLAttrV )
	{
	    if( nonMasterUpAttrAVSfromEntryp && (*nonMasterUpAttrAVSfromEntryp) != NULLAV )
	    {
		/* Search for the value within the cache.. */
		for( avs = (*nonMasterUpAttrAVSfromEntryp) ; avs != NULLAV ; avs = avs -> avseq_next )
	    	{
	    	    if( AttrV_cmp( &(avs -> avseq_av), nonMasterUpAv ) == 0 )
		    {
		    	hasAttrBeenLoadedByAnonMasterSource = TRUE ;
		    	break ;
		    }
		}
	    }
	}

	if( nonMasterUpValuecp != NULLCP )
	    free( nonMasterUpValuecp ) ;

	if( nonMasterUpAv != NULLAttrV )
	    AttrV_free( nonMasterUpAv ) ;

	return( hasAttrBeenLoadedByAnonMasterSource ) ;
}


/*
 * Add the "nonMasterUpdatedAttrType" value (an attribute type)
 * to a local cache.
 */

void
insertNonMasterUpAtValue( nonMasterUpAttrAVSfromEntryp, nonMasterUpAttrTtoBeAdded )
AV_Sequence * 	nonMasterUpAttrAVSfromEntryp ; /* "nonMasterUpdatedAttrType" cache */
AttributeType	nonMasterUpAttrTtoBeAdded ;
{
AttributeValue  nonMasterUpAv = NULLAttrV ;
char *		nonMasterUpValuecp = NULLCP ;
static	AttributeType nonMasterUpAt = NULLAttrT ;

	if( nonMasterUpAt == NULLAttrT )
	    nonMasterUpAt =  str2AttrT( BL_NON_MASTER_UPDATED_ATTR_TYPE ) ;

	if((nonMasterUpAt != NULLAttrT ) &&
	   (nonMasterUpValuecp = AttrT2pstr( nonMasterUpAttrTtoBeAdded )) != NULLCP &&
	   (nonMasterUpAv      = str2AttrV(  nonMasterUpValuecp, nonMasterUpAt -> oa_syntax )) != NULLAttrV )
	{
	    (void)insertAVintoAVS( nonMasterUpAttrAVSfromEntryp, nonMasterUpAv ) ;
	}

	if( nonMasterUpValuecp != NULLCP )
	    free( nonMasterUpValuecp ) ;

	if( nonMasterUpAv != NULLAttrV )
	    AttrV_free( nonMasterUpAv ) ;

	return ;
}


/*
 * Remove the "nonMasterUpdatedAttrType" value (an attribute type) from
 * a local cache.
 */

void
removeNonMasterUpAtValue( nonMasterUpAttrAVSfromEntryp, nonMasterUpAttrTtoBeRemoved )
AV_Sequence * 	nonMasterUpAttrAVSfromEntryp ; /* "nonMasterUpdatedAttrType" cache */
AttributeType	nonMasterUpAttrTtoBeRemoved  ;
{
char *	nonMasterUpValuecp = NULLCP ;
AttributeValue	      nonMasterUpAv ;
static	AttributeType nonMasterUpAt = NULLAttrT ;

	if( nonMasterUpAt == NULLAttrT )
	    nonMasterUpAt =  str2AttrT( BL_NON_MASTER_UPDATED_ATTR_TYPE ) ;

	if((nonMasterUpAt     != NULLAttrT ) &&
	   (nonMasterUpValuecp = AttrT2pstr( nonMasterUpAttrTtoBeRemoved )) != NULLCP &&
	   (nonMasterUpAv      = str2AttrV(  nonMasterUpValuecp, nonMasterUpAt -> oa_syntax )) != NULLAttrV )
	{
	    (void)removeAVfromAVS( nonMasterUpAttrAVSfromEntryp, nonMasterUpAv ) ;
	}
	
	if( nonMasterUpValuecp != NULLCP )
	    free( nonMasterUpValuecp ) ;
	
	if( nonMasterUpAv != NULLAttrV )
	    AttrV_free( nonMasterUpAv ) ;

	return ;
}


/*
 * Update the "nonMasterUpdateAttrType" values now that a DSAP sequence
 * has succeeded..
 */

void
addOrRemoveNonMasterUpAtValues( entryDN, nonMasterUpAttrAVSfromEntry, reqMasterUpAttrAVSfromEntry )
DN		entryDN ;
AV_Sequence	nonMasterUpAttrAVSfromEntry, reqMasterUpAttrAVSfromEntry ;
{
AV_Sequence	currNonMstUpAtAVS    = nonMasterUpAttrAVSfromEntry,
		currReqNonMstUpAtAVS = reqMasterUpAttrAVSfromEntry ;
struct	entrymod * baseModNodep = NULLMOD, * baseRemoveModNodep = NULLMOD, * currModNodep = NULLMOD ;
static	AttributeType nonMasterUpAtat = NULLAttrT ;
struct 	DSError	 * dserrorp ;
char *	foundFlagscp = NULLCP ;
int	AVcompCnt = 0, currNonMstUpAtavFound, numOfDelValues = 0 ;

	if( nonMasterUpAtat == NULLAttrT )
	    nonMasterUpAtat =  str2AttrT( BL_NON_MASTER_UPDATED_ATTR_TYPE ) ;

	if( nonMasterUpAtat == NULLAttrT || (currNonMstUpAtAVS == NULLAV && currReqNonMstUpAtAVS == NULLAV) )
	    return ;

	AVcompCnt = countAVcomps( reqMasterUpAttrAVSfromEntry ) ;

	if( (foundFlagscp = malloc( (unsigned)AVcompCnt )) != NULLCP )
	    for( --AVcompCnt ; AVcompCnt >= 0 ; AVcompCnt-- )
	    	*(foundFlagscp + AVcompCnt) = 'n' ;

	/* Differ the list of cached "nonMasterUpdateAttrType" values and the
	   required list of "nonMasterUpdateAttrType" values */

	while( currNonMstUpAtAVS != NULLAV )
	{
	    currNonMstUpAtavFound = FALSE ; AVcompCnt = 0 ;

	    currReqNonMstUpAtAVS = reqMasterUpAttrAVSfromEntry ;

	    while( currNonMstUpAtavFound == FALSE && currReqNonMstUpAtAVS != NULLAV )
	    {
		if( foundFlagscp == NULLCP || *(foundFlagscp + AVcompCnt) == 'n' )
		{
		    if( AttrV_cmp( &(currNonMstUpAtAVS -> avseq_av),
				   &(currReqNonMstUpAtAVS -> avseq_av ) ) == 0 )
		    {
		    	if( foundFlagscp != NULLCP )
			    *(foundFlagscp + AVcompCnt) = 'y' ;

		    	currNonMstUpAtavFound = TRUE ;
		    }
		    else
		    {
		    	++AVcompCnt ;
		    	currReqNonMstUpAtAVS = currReqNonMstUpAtAVS -> avseq_next ;
		    }
		}
		else
		{
		    ++AVcompCnt ;
		    currReqNonMstUpAtAVS = currReqNonMstUpAtAVS -> avseq_next ;
		}
	    }

	    if( currNonMstUpAtavFound == FALSE )
	    {
		/* Value must be removed from the "nonMasterUpdatedAttrType" attribute values.. */

		currModNodep = create_attr_mod( EM_REMOVEVALUES, nonMasterUpAtat, &(currNonMstUpAtAVS->avseq_av) ) ;
		append_attr_mod( &baseRemoveModNodep, currModNodep ) ;
		numOfDelValues++ ;
	    }

	    currNonMstUpAtAVS = currNonMstUpAtAVS -> avseq_next ;
	}


	/* Now check for any values that are to be added.. */

	if( foundFlagscp != NULLCP )
	{
	    currReqNonMstUpAtAVS = reqMasterUpAttrAVSfromEntry ; AVcompCnt = 0 ;
	
	    while( currReqNonMstUpAtAVS != NULLAV )
	    {
		if( *(foundFlagscp + AVcompCnt) == 'n' ) 
		{
		    if( nonMasterUpAttrAVSfromEntry == NULLAV && baseModNodep == NULLMOD )
		    {
		    	/* No values currently held.. */
		    	currModNodep = create_attr_mod( EM_ADDATTRIBUTE, nonMasterUpAtat, &(currReqNonMstUpAtAVS->avseq_av) ) ;
		    	append_attr_mod( &baseModNodep, currModNodep ) ;
		    }
		    else
		    {
		    	currModNodep = create_attr_mod( EM_ADDVALUES, nonMasterUpAtat, &(currReqNonMstUpAtAVS->avseq_av) ) ;
		    	append_attr_mod( &baseModNodep, currModNodep ) ;
		    }
		}

		++AVcompCnt ;
		currReqNonMstUpAtAVS = currReqNonMstUpAtAVS -> avseq_next ;
	    }

	    free( (char *)foundFlagscp ) ;
	}

	/* Apply the updates.. */

	/* If no adds and all values being removed then a remove attribute is required.. */
	AVcompCnt = countAVcomps( nonMasterUpAttrAVSfromEntry ) ;

	if( baseModNodep == NULLMOD && AVcompCnt > 0 && AVcompCnt == numOfDelValues )
	{
	    free_attr_mod_list( baseRemoveModNodep ) ; baseRemoveModNodep = NULLMOD ;
	    currModNodep = create_attr_mod( EM_REMOVEATTRIBUTE, nonMasterUpAtat, NULLAttrV ) ;
	    append_attr_mod( &baseModNodep, currModNodep ) ;
	}
	else
	{
	     /* Adds before removes */
	     append_attr_mod( &baseModNodep, baseRemoveModNodep ) ;
	}

	if( baseModNodep != NULLMOD )
	{
	    if( modifyDirectory( baseModNodep, entryDN, &dserrorp ) != OK )
	    	ds_error_free( dserrorp ) ;

	    free_attr_mod_list( baseModNodep ) ;
	}

	return ;
}



void
setUpTheAttrLineErrorMsgsAndRouteConfigErrors( operationalMode, OFD, currRAAp, dserrorp )
int	operationalMode ;
struct	outputFileDetails OFD[] ;
struct 	rootedAtAttributes * currRAAp ;
struct 	DSError	* dserrorp ;
{
struct	attributeLine * currALp ;
int	errorClass, errorType, procReq, errorMatchedOK=FALSE ;


	if( !dserrorp )
	    return ;


	/* First check for a DSAP error that is not attribute specific.. */
	if( dserrorp -> dse_type != DSE_ATTRIBUTEERROR )
	{
	    /* Error applies to the sequence of attributes.. */
	    errorClassTypeAndMsg( dserrorp, &errorClass, &errorType, &(currRAAp -> attrSequenceErrorMsgcp), ((char **)NULL),
			0, 0, NULLAttrT, NULLAttrV, FALSE, &errorMatchedOK ) ;
	}
	else
	{
	    /* Attribute line specific.. */
	    
	    currALp = currRAAp -> attrLinep ;

	    while( currALp != NULLALP && currRAAp -> attrSequenceErrorMsgcp == NULLCP && 
									errorMatchedOK == FALSE)
	    {
		errorType = 0 ;
	    
	    	if( currALp -> attrUsed   == FALSE &&
	    	    currALp -> errorMsgcp == NULLCP   )
	    	{
		    errorClassTypeAndMsg( dserrorp, &errorClass, &errorType,
		    	&(currRAAp -> attrSequenceErrorMsgcp), &(currALp -> errorMsgcp),
		        currALp -> actionDefinedByAttrLine, currALp -> modificationInitiated, 
			currALp -> at, currALp -> av, currALp -> attrIsMasteredByCurrentSource,
			&errorMatchedOK ) ;

		    if( errorType != 0 )
		    {
		    	/* Check the configuration details for a routing requirement.. */

		    	checkForSendToFileReq( currALp -> attrIsMasteredByCurrentSource,
		    		currALp -> modificationInitiated, errorClass, errorType, &procReq ) ;

	    	    	if( operationalMode == NON_INTERACT_OPER_MODE &&
			    procReq == PROCESSTHEUPDATE )
	    		    	procReq = OUTPUTPROBLEMFILE ;

		    	if( procReq != PROCESSTHEUPDATE )
		    	{
		    	    transferAttribute( OFD, procReq, currALp->attrLinecp, currALp -> errorMsgcp, NULLCP ) ;
			    currALp -> attrUsed = TRUE ;
		    	}
		    }
		}

	    	currALp = currALp -> nextAttrLinep ;
	    }

	    /* Check that the error was matched against an attribute line.. */
	    if( errorMatchedOK == FALSE )
		currRAAp -> attrSequenceErrorMsgcp = error2pstr( dserrorp ) ;

	    if( currRAAp -> attrSequenceErrorMsgcp == NULLCP )
	    	ds_error_free( dserrorp ) ;

	    /* called here due to the presence of ds_error_free() within error2pstr() */
	}

	return ;
}


int
anyAttrsStillToBeProcessed( baseALp )
struct	attributeLine * baseALp ;
{
int	anyAttrsRemainingUnprocessed = FALSE ;
struct	attributeLine * currALp = baseALp ;

	while( currALp != NULLALP )
	{
	    if( currALp -> attrUsed == FALSE )
	    {
                anyAttrsRemainingUnprocessed = TRUE ;
	        break ;
	    }

	    currALp = currALp -> nextAttrLinep ;
	}

	return( anyAttrsRemainingUnprocessed ) ;
}


int
anyUnprocessedAttrsWithErrors( currRAAp )
struct 	rootedAtAttributes * currRAAp ;
{
int	anyAttrsRemainingWithErrors = FALSE ;
struct	attributeLine * currALp ;

	if( currRAAp -> attrSequenceErrorMsgcp != NULLCP )
	{
            anyAttrsRemainingWithErrors = TRUE ;
	}
	else
	{
	    currALp = currRAAp -> attrLinep ;

	    while( currALp != NULLALP )
	    {
	    	if( currALp -> attrUsed   == FALSE &&
	    	    currALp -> errorMsgcp != NULLCP  )
	    	{
                    anyAttrsRemainingWithErrors = TRUE ;
	            break ;
	        }

	        currALp = currALp -> nextAttrLinep ;
	    }
	}

	return( anyAttrsRemainingWithErrors ) ;
}




/*
 * ACL attributes need special treatment due to the presence of defaults for
 * the child, entry and default components.
 */
int
aclComponentIsToBeDeleted( baseAclALp, aclCompcp, aclat )
struct  attributeLine *baseAclALp ;
char  * aclCompcp ;
AttributeType	aclat ;
{
int	deleteACLcomp = FALSE ;
struct  attributeLine * currALp ;
AttributeValue	aclav = NULLAttrV ;

	removeAllWhiteSpaces( aclCompcp ) ;

	aclav = str2AttrV( aclCompcp, aclat->oa_syntax ) ;

	/* Check that this ADD request is not affected by any DELETEVALUEACTIONs.. */
	for( currALp = baseAclALp ; aclav != NULLAttrV && currALp != NULLALP && AttrT_cmp( currALp->at, aclat) == 0 ; currALp = currALp -> nextAttrLinep )
	{
	    if( currALp->attrUsed == FALSE && currALp->errorMsgcp == NULLCP &&
		currALp->actionDefinedByAttrLine == DELETEVALUEACTION       &&
		currALp->av != NULLAttrV )
	    {
		if( AttrV_cmp( aclav, currALp->av ) == 0 )
		{
		    deleteACLcomp = TRUE ;
		    break ;
		}
	    }
	}
	
	if( aclav != NULLAttrV )
	    AttrV_free( aclav ) ;

	return( deleteACLcomp ) ;
}

void
formACLmodifications( baseAclALpp, baseModNodepp, aclAVSfromEntry, aclat )
struct attributeLine **baseAclALpp ;
struct entrymod	     **baseModNodepp ;
AV_Sequence	aclAVSfromEntry ; /* The acl values currently held for the entry */
AttributeType	aclat ;
{
char	aclBuildAVSbuffer[ BIGBUFFERSIZE ], *currAclBuildcp = aclBuildAVSbuffer ;
char *	avscp, * avcp, * retcp, * equalscp ;
struct  attributeLine *currALp, *finalAclALp ;
struct  entrymod *baseAclModNodep = NULLMOD, *currAclModNodep = NULLMOD ;
AV_Sequence	aclavs ;

	aclBuildAVSbuffer[0] = '\0' ;

	/* Initially delete the existing ACL.. */
	baseAclModNodep = create_attr_mod( EM_REMOVEATTRIBUTE, aclat, NULLAttrV ) ;

	/*
	 * Extract the attributes from the AVS held in the Directory entry.. 
	 */
	
	avscp = avs2pstr( aclAVSfromEntry ) ;

	if( avscp != NULLCP )
	{
	    /* Extract attribute component by component */
	    while( (retcp = strrchr( avscp, '\n' )) != NULLCP )
	    {
		if( *(retcp + 1) != '\0' )
		{
		    if( (equalscp = strchr( retcp, '=' )) != NULLCP )
		    {
			if( aclComponentIsToBeDeleted( *baseAclALpp, equalscp+1, aclat ) == FALSE )
			{
		    	    sprintf( currAclBuildcp, "%s &", equalscp+1 ) ; /* Skipping the "\nacl=" */
		    	    currAclBuildcp = currAclBuildcp + strlen( equalscp+1 ) + 2 ;
			}
		    }
		}
		
		*retcp = '\0' ; /* Null terminating at the current right most '\n' */
	    }

	    /* Not forgetting the final component.. */
	    if( aclComponentIsToBeDeleted( *baseAclALpp, avscp, aclat ) == FALSE )
	    {
	    	sprintf( currAclBuildcp, "%s &", avscp ) ; /* Skipping the "=" */
	    	currAclBuildcp = currAclBuildcp + strlen( avscp ) + 2 ;
	    }

	    free( avscp ) ;
	}

	/* Now append any values to be added.. */
	for( currALp = *baseAclALpp ; currALp != NULLALP && AttrT_cmp( currALp->at, aclat) == 0 ; currALp = currALp -> nextAttrLinep )
	{
	    if( currALp->attrUsed == FALSE && currALp->errorMsgcp == NULLCP )
	    {
		if( currALp->actionDefinedByAttrLine == ADDATTRACTION || 
			currALp->actionDefinedByAttrLine == ADDVALUEACTION )
		{
		    if( (avcp = strDupTidyStringRemLineConts( currALp -> attrLinecp )) != NULLCP )
		    {
			if( (equalscp = strchr( avcp, '=' )) != NULLCP )
			{
			    if( aclComponentIsToBeDeleted( *baseAclALpp, equalscp+1, aclat ) == FALSE )
			    {
				sprintf( currAclBuildcp, "%s &", equalscp+1 ) ; /* Skipping the "acl=" */
				currAclBuildcp = currAclBuildcp + strlen( equalscp+1 ) + 2 ;
			    }
			}

			free( avcp ) ;
		    }

		    /* Note: any DELETEATTRACTIONs will be ignored !! */
		}
	    }

	    finalAclALp = currALp ; /* Eventually */
	}

	/* Remove the final '&' from the AVS build buffer.. */
	if( currAclBuildcp > aclBuildAVSbuffer && *(currAclBuildcp-1) == '&' )
	    *(currAclBuildcp-1) = '#' ;

	/* Now generate the AVS.. */
	if( (aclavs = str2avs( aclBuildAVSbuffer, aclat )) != NULLAV )
	{
	    currAclModNodep = create_attr_mod_from_AVS( EM_ADDATTRIBUTE, aclat, aclavs ) ;

	    if( currAclModNodep != NULLMOD )
	    {
		append_attr_mod( &baseAclModNodep, currAclModNodep ) ;

	    	/* Append this onto the current all attribute types modifcation list */
		append_attr_mod( baseModNodepp, baseAclModNodep ) ;
	    }
	    
	    avs_free( aclavs ) ;
	}

	*baseAclALpp = finalAclALp ;

	return ;
}

/*
 * Remove the attribute value from the attribute sequence cache.
 * If the value was the last for the given attribute type and if there 
 * are no values listed for addition this cycle then indicate
 * that a REMOVEATTRIBUTE operation is required, as opposed to
 * a REMOVEVALUES.
 */

int
removeAttrVIndicateIfDelAttrReq( attrsASfromEntry, delValueAt, delValueAv, baseModNodep )
Attr_Sequence	attrsASfromEntry ;
AttributeType	delValueAt ;
AttributeValue	delValueAv ;
struct  entrymod * baseModNodep ;
{
int	delAttrReq = FALSE, delValueAvFound = FALSE, countOfDelAtattributes = 0 ;
Attr_Sequence	curras = attrsASfromEntry ;
AV_Sequence	curravs ;

	/* Find the attribute sequence that corresponds to the attribute type.. */
	for( curras = attrsASfromEntry ; curras != NULLATTR ; curras = curras -> attr_link )
	{
	    if( AttrT_cmp( curras->attr_type, delValueAt ) == 0 )
	    {
		if( removeAVfromAVS( &(curras -> attr_value), delValueAv ) == OK )
		{
		    delValueAvFound = TRUE ;

	    	    for( curravs = curras -> attr_value ; curravs != NULLAV ; curravs = curravs -> avseq_next )
		    	++countOfDelAtattributes ;
		}

		break ;
	    }
	}

	/* Before replacing a REMOVE VALUES with a REMOVE ATTRIBUTE we must ensure :-
	 * 1) The REMOVE VALUES is to remove the last attribute value within the Directory entry
	 * 2) We do not already have an add request for the attribute type
	 *    e.g.	>userClass = 3rdyr
	 *    		<userClass = 2ndyr
	 *    (when the Directory only holds "userClass=2ndyr") 
	 *    in which case the remove value should be used.
	 */

	if( delValueAvFound == TRUE && countOfDelAtattributes == 0 &&
	    modificationIsAlreadyListed( baseModNodep, EM_ADDATTRIBUTE, delValueAt ) == FALSE &&
	    modificationIsAlreadyListed( baseModNodep, EM_ADDVALUES,    delValueAt ) == FALSE   )
	{
	    delAttrReq = TRUE ;
	}

	return( delAttrReq ) ;

}


/* Rules :-
 *
 *	1) Delete attribute or attribute value only permitted if source is
 *	   a master source for that attribute type
 *
 *	2) When a master source adds an attribute all existing values (if any)
 *	   will be cleared down if the "nonMasterUpdatedAttrType" attribute
 *	   has the attribute type as a value (which indicates a non-master
 *	   source has already added a value.)
 *
 *	3) A non-master data source is permitted to add an attribute value
 *	   (or more if added at the same time) if the directory does not have any values for it already.
 *
 *	4) When a non-master data source attempts to add an attribute value
 *	   an ADD ATTRIBUTE request is used to ensure that the data will only
 *	   be added if it is the first value.
 */

void
updateAttribute( operationalMode, currRAAp, sourceNamecp,
			entryDN, baseDataSourceLevelp, OFD, inFileType )
int	operationalMode ;
struct 	rootedAtAttributes * currRAAp ;
char *	sourceNamecp ;
DN	entryDN ;
struct 	dataSourceLevel * baseDataSourceLevelp ;
struct	outputFileDetails OFD[] ;
int	inFileType ;
{
Attr_Sequence	otherAttrsASfromEntry    = NULLATTR, /* The non-ACL, object class and nonMasterUpdatedAttrType attributes from the entry */
		reqOtherAttrsASfromEntry = NULLATTR; /* A cache copy with any requested remove value/attribute operations applied */
AV_Sequence	nonMasterUpAttrAVSfromEntry = NULLAV, /* A cache of the "nonMasterUpdatedAttrType" values from the current entry */
		reqNonMasterUpAttrAVSfromEntry = NULLAV, /* A cache copy */
		aclAVSfromEntry = NULLAV, objClsAVSfromEntry = NULLAV ;
struct	attributeLine *currALp, *prevALp, *newALp ;
int	allAttrsProcessed, procReq, errorClass, errorType, actionReq, attrTypeHasDirectoryValue,
	anyCouldNotDetermineHowToProcessLinesToBeHandled, anyDeletesWhenNonMasterToBeProcess ;
char *	errorMsgcp ;
struct	DSError  * dserrorp ;
struct	entrymod * baseModNodep, * currModNodep ;
RDN	entryRDN ;
struct	attributeLine ** baseALpp ;
static	AttributeType objClsat = NULLAttrT, aclat = NULLAttrT ;

	if( !currRAAp )
	    return ;

	entryRDN = currRAAp   -> rdn ;
	baseALpp = &(currRAAp -> attrLinep) ;

	if( (!baseALpp) || ((*baseALpp) == NULLALP) )
	    return ;

	if( objClsat == NULLAttrT )
	    objClsat =  str2AttrT( BL_OBJECT_CLASS ) ;


	if( aclat == NULLAttrT )
	    aclat =  str2AttrT( BL_ACCESS_CONTROL_LIST ) ;

	/*
	 * Now handle any attribute updates..
	 */

	setUpTheMasterAttrLineDetails( baseDataSourceLevelp, *baseALpp, sourceNamecp ) ;

	readObjClsACLNonMasterUpAttrAndOtherAttrsAndCorrectDirectory( entryDN, &aclAVSfromEntry, 
		&objClsAVSfromEntry, &nonMasterUpAttrAVSfromEntry, &otherAttrsASfromEntry ) ;

	allAttrsProcessed = FALSE ;

	while( allAttrsProcessed == FALSE )
	{
	    baseModNodep = currModNodep = NULLMOD ;

	    anyCouldNotDetermineHowToProcessLinesToBeHandled = FALSE ;
	    anyDeletesWhenNonMasterToBeProcess = FALSE ;

	    if( otherAttrsASfromEntry != NULLATTR )
	    	reqOtherAttrsASfromEntry = as_cpy( otherAttrsASfromEntry ) ;		
	    
	    if( nonMasterUpAttrAVSfromEntry != NULLAV )
	    	reqNonMasterUpAttrAVSfromEntry = avs_cpy( nonMasterUpAttrAVSfromEntry ) ;

	    if( currRAAp -> attrSequenceErrorMsgcp != NULLCP )
	    {
	    	free( currRAAp -> attrSequenceErrorMsgcp ) ; currRAAp -> attrSequenceErrorMsgcp = NULLCP ;
	    }

	    /* Check for delete attribute or delete value requests when source is not a master source
	       or unknown requests.. */

	    currALp = *baseALpp ;

	    while( currALp != NULLALP )
	    {
		if( currALp -> attrUsed == FALSE )
		{
		    if( currALp -> errorMsgcp != NULLCP )
		    {
		    	free( currALp -> errorMsgcp ) ; currALp -> errorMsgcp = NULLCP ;
		    }

	    	    if( determineActionReq( currALp -> attrLinecp, &actionReq, inFileType, FALSE, currALp, bulkLoadConfig.updatesToExistingEntries ) != OK )
		    {
			currALp -> actionDefinedByAttrLine = 0 ;
		    	currALp -> errorMsgcp = strdup( "Could not determine how to process the line" ) ;

			anyCouldNotDetermineHowToProcessLinesToBeHandled = TRUE ;
	    	    }
		    else
 		    {
			currALp -> actionDefinedByAttrLine = actionReq ;
		    
		    	if( currALp -> attrIsMasteredByCurrentSource == FALSE )
		    	{
                            if( actionReq == DELETEATTRACTION || actionReq == DELETEVALUEACTION )
			    {
				if( actionReq == DELETEATTRACTION )
				{
			    	    procReq = bulkLoadConfig.configErrorProcReq[ DELETEATTRIBUTEWHENNOTMASTERSOURCE ] ;
		    	    	    currALp -> errorMsgcp = strdup( "REMOVE ATTRIBUTE request rejected since NOT the master source" ) ;
				}
			        else if( actionReq == DELETEVALUEACTION)
			        {
			    	    procReq = bulkLoadConfig.configErrorProcReq[ DELETEVALUEWHENNOTMASTERSOURCE ] ;
		    	    	    currALp -> errorMsgcp = strdup( "REMOVE VALUE request rejected since NOT the master source" ) ;
			    	}

	    		    	if( operationalMode == NON_INTERACT_OPER_MODE && procReq == PROCESSTHEUPDATE )
	    			    	procReq = OUTPUTPROBLEMFILE ;

			    	if( procReq != PROCESSTHEUPDATE )
			    	{
		    	    	    transferAttribute( OFD, procReq, currALp->attrLinecp, currALp -> errorMsgcp, NULLCP ) ;
			    	    currALp -> attrUsed = TRUE ;
				}
				else anyDeletesWhenNonMasterToBeProcess = TRUE ;
			    }
		    	}
			else if( (actionReq == ADDATTRACTION || actionReq == ADDVALUEACTION) && 
								AttrT_cmp( currALp -> at, objClsat ) == 0 )
			{
			    /* Check if the object class value is already held within the Directory */
			    if( findAttrVinAVS( objClsAVSfromEntry, currALp -> av ) != NULLAttrV )
			    {
			    	if( actionReq == ADDATTRACTION )
				{
			    	    procReq = bulkLoadConfig.configErrorProcReq[ ADDATTRIBUTETHATALREADYEXISTS ] ;
				    currALp -> errorMsgcp = strdup( "ADD ATTRIBUTE request rejected, object class value already in directory" ) ;
				}
			    	else
				{
				    procReq = bulkLoadConfig.configErrorProcReq[ ADDVALUETHATALREADYEXISTS ] ;
				    currALp -> errorMsgcp = strdup( "ADD VALUE request rejected, object class value already in directory" ) ;
				}

	    		    	if( operationalMode == NON_INTERACT_OPER_MODE && procReq == PROCESSTHEUPDATE )
	    			    procReq = OUTPUTPROBLEMFILE ;

				if( procReq != PROCESSTHEUPDATE )
				{
		    	    	    transferAttribute( OFD, procReq, currALp->attrLinecp, currALp -> errorMsgcp, NULLCP ) ;
			    	    currALp -> attrUsed = TRUE ;
				}
			    }
			}
		    }
		}

		currALp = currALp -> nextAttrLinep ;
	    }


	    /* Now generate the modifications linked list.. */

	    currALp = *baseALpp ; prevALp = NULLALP ;

	    while( currALp != NULLALP )
	    {
		if( currALp -> attrUsed   == FALSE &&
		    currALp -> errorMsgcp == NULLCP  )
		{		    
		    if( aclat != NULLAttrT &&
		    	AttrT_cmp( currALp -> at, aclat ) == 0 )
		    {
		    	/* Create the modification nodes for the ACL attribute lines... */
			formACLmodifications( &currALp, &baseModNodep, aclAVSfromEntry, aclat ) ;

			/* ... Will have left currALp pointing to the last AL node with an ACL attribute... */

			prevALp = currALp ;
			currALp = currALp -> nextAttrLinep ;

			continue ;
		    }

		    (void)determineActionReq( currALp -> attrLinecp, &actionReq, inFileType, FALSE, currALp, bulkLoadConfig.updatesToExistingEntries ) ;

		    if( actionReq == DELETEATTRACTION )
		    {
		    	currModNodep = create_attr_mod( EM_REMOVEATTRIBUTE,  currALp -> at, NULLAttrV ) ;

			append_attr_mod( &baseModNodep, currModNodep ) ;
			
		    	currALp -> modificationInitiated = EM_REMOVEATTRIBUTE ;

			removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
		    }
		    else if( actionReq == DELETEVALUEACTION )
		    {
		    	/* Check if we are attempting to remove the last attribute value for this attribute type
 			   (which would cause a constaint violation error).. */

		    	if( removeAttrVIndicateIfDelAttrReq( reqOtherAttrsASfromEntry, currALp -> at, currALp -> av, baseModNodep ) == TRUE )
			{
			    currModNodep = create_attr_mod( EM_REMOVEATTRIBUTE, currALp -> at, NULLAttrV ) ;
			    currALp -> modificationInitiated = EM_REMOVEATTRIBUTE ;
			    removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
			}
			else
			{
			    currModNodep = create_attr_mod( EM_REMOVEVALUES,  currALp -> at, currALp -> av ) ;
		    	    currALp -> modificationInitiated = EM_REMOVEVALUES ;
			}

			append_attr_mod( &baseModNodep, currModNodep ) ;
		    }
		    else if( actionReq == ADDATTRACTION )
		    {
		    	
			if( currALp -> attrIsMasteredByCurrentSource == TRUE )
		    	{
			    /* Check if the attribute type should be cleared down.. */
		    	    if( bulkLoadConfig.disableBulkAttributeUsage == FALSE &&
			    	bulkLoadConfig.valueClearDownPermittedOnFirstMasterUpdate == TRUE &&
				AttrT_cmp( currALp -> at, objClsat ) != 0 &&
			    	hasAttrBeenLoadedByAnonMaster(
					&reqNonMasterUpAttrAVSfromEntry, currALp -> at ) == TRUE &&
				findAttrTypeRdnComp( currALp -> at, entryRDN) == FALSE &&
				removeRequestLikelyToSucceed( otherAttrsASfromEntry, currALp -> at ) == TRUE &&
			    	modificationIsAlreadyListed( baseModNodep, EM_REMOVEATTRIBUTE, currALp -> at ) == FALSE )
			    {
			    	/* Source is the(/one of the) master source(s) for this
			           attribute so clear all existing attribute values */

				if( inFileType == DMFORMATFILEINPUT )
				{
				    /* the "dmformat" can not represent deletions so delete now.. */
				    if(modifyAttribute( EM_REMOVEATTRIBUTE, entryDN, currALp -> at, NULLAttrV,
		    						&errorMsgcp, &errorClass, &errorType ) == NOTOK )
		    	    	    {
				    	free( errorMsgcp ) ;
				    }
				    else
				    {
				    	/* Update both the cached and required nonMasterUpdateAttrType value lists.. */
				    	removeNonMasterUpAtValue( &nonMasterUpAttrAVSfromEntry, currALp -> at  ) ;
				    	removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;

					removeAttrOrValue( entryDN, currALp -> at, currALp -> av, 
								(nonMasterUpAttrAVSfromEntry == NULLAV) ? TRUE : FALSE ) ;

					/* Update the cached Directory values.. */
					(void)removeATfromAS( &otherAttrsASfromEntry,    currALp -> at ) ;
					(void)removeATfromAS( &reqOtherAttrsASfromEntry, currALp -> at ) ;
				    }
				}
				else
				{
				    /* inFileType == NEWDMFORMATINPUT */

				    /* Create a new attribute line node and insert it in to the linked list .. */
				    if( (newALp = (struct attributeLine *)create_lone_attributeLine_node( DELETEATTRCHAR,
									currALp -> at, NULLAttrV )) != NULLALP )
				    {
					newALp -> attrIsMasteredByCurrentSource = TRUE ;
					newALp -> actionDefinedByAttrLine = DELETEVALUEACTION ;
		    	    		newALp -> modificationInitiated   = EM_REMOVEATTRIBUTE ;

					/* Insert the node before the current node.. */
					if( currALp == *baseALpp )
					{
					    *baseALpp = newALp ;
					    newALp -> nextAttrLinep = currALp ;
					}
					else
					{
					    prevALp -> nextAttrLinep = newALp ;
					    newALp  -> nextAttrLinep = currALp ;
					}
					    
		    	    		currModNodep = create_attr_mod( EM_REMOVEATTRIBUTE,  newALp -> at, newALp -> av ) ;
			    		append_attr_mod( &baseModNodep, currModNodep ) ;
	
			    		removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, newALp -> at ) ;
				    }
				}
			    }
			}


			/* Does the Directory currently hold the a value for this attribute type.. */
			attrTypeHasDirectoryValue = (findASbyAttrT( otherAttrsASfromEntry, currALp -> at ) != NULLATTR) ;

			if((currALp -> attrIsMasteredByCurrentSource == FALSE &&
			 	bulkLoadConfig.disableBulkAttributeUsage == FALSE) ||
			   ((bulkLoadConfig.disableBulkAttributeUsage == TRUE ||
			     currALp -> attrIsMasteredByCurrentSource == TRUE   ) &&
			    ((attrTypeHasDirectoryValue == TRUE  && 
			    	modificationIsAlreadyListed( baseModNodep, EM_REMOVEATTRIBUTE, currALp -> at ) == TRUE && 
			    	modificationIsAlreadyListed( baseModNodep, EM_ADDATTRIBUTE, currALp -> at ) == FALSE ) ||
			     (attrTypeHasDirectoryValue == FALSE && modificationIsAlreadyListed( baseModNodep, EM_ADDATTRIBUTE, currALp -> at ) == FALSE ) )) )
			{
		    	    /* Add new attribute..
	  	    	       Note : if this is not the master source then the add will fail if the attribute already exists */

		    	    currModNodep = create_attr_mod( EM_ADDATTRIBUTE,  currALp -> at, currALp -> av ) ;

			    append_attr_mod( &baseModNodep, currModNodep ) ;

		    	    currALp -> modificationInitiated = EM_ADDATTRIBUTE ;

			    if( currALp -> attrIsMasteredByCurrentSource == TRUE )
			    	removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
			    else
			    	insertNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
		    	}
		    	else
		    	{
		    	    /* Merely add a value (master source)... */

		    	    currModNodep = create_attr_mod( EM_ADDVALUES,  currALp -> at, currALp -> av ) ;

			    append_attr_mod( &baseModNodep, currModNodep ) ;

		    	    currALp -> modificationInitiated = EM_ADDVALUES ;

			    removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
			}
		    }
		    else if( actionReq == ADDVALUEACTION )
		    {
			if( currALp -> attrIsMasteredByCurrentSource == TRUE ||
			    bulkLoadConfig.disableBulkAttributeUsage == TRUE ||
			    modificationIsAlreadyListed( baseModNodep, EM_ADDATTRIBUTE, currALp -> at ) == TRUE )
			{
		    	    currModNodep = create_attr_mod( EM_ADDVALUES,  currALp -> at, currALp -> av ) ;

			    append_attr_mod( &baseModNodep, currModNodep ) ;

		    	    currALp -> modificationInitiated = EM_ADDVALUES ;

			    if( currALp -> attrIsMasteredByCurrentSource == TRUE )
			    	removeNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
				/* ... will probably be listed already but just in case ! */
			}
			else
			{
			    /* Since source is not a master source for this attribute type
			       an ADD ATTRIBUTE request is used which will fail if the attribute is already present */

		    	    currModNodep = create_attr_mod( EM_ADDATTRIBUTE,  currALp -> at, currALp -> av ) ;

			    append_attr_mod( &baseModNodep, currModNodep ) ;

		    	    currALp -> modificationInitiated = EM_ADDATTRIBUTE ;

			    /* If this add attribute succeeds then  the nonMasterUpdatedAttrType
			       should have this attribute type added as a value.. */
			    insertNonMasterUpAtValue( &reqNonMasterUpAttrAVSfromEntry, currALp -> at ) ;
			}
		    }
		}

		prevALp = currALp ;
		currALp = currALp -> nextAttrLinep ;
	    }


	    if( anyCouldNotDetermineHowToProcessLinesToBeHandled == TRUE ||
	    	anyDeletesWhenNonMasterToBeProcess == TRUE )
	    {
		if( operationalMode == NON_INTERACT_OPER_MODE )
		{
		    transferRDNattrs( OFD, OUTPUTPROBLEMFILE, *baseALpp, "Errors require interactive processing",
	 								currRAAp -> attrSequenceErrorMsgcp ) ;
	    	    allAttrsProcessed = TRUE ;
	    	}
		else
		{
		    allAttrsProcessed = editAttributeSequence( inFileType, OFD, entryRDN, currRAAp ) ;

		    if( allAttrsProcessed == FALSE )
			setUpTheMasterAttrLineDetails( baseDataSourceLevelp, *baseALpp, sourceNamecp ) ;
		}
	    }
	    else {

	    	/* Now apply the modifications to the directory.. */

	    	if( baseModNodep == NULLMOD ||
		    modifyDirectory( baseModNodep, entryDN, &dserrorp ) != OK )
	    	{
		    /* Run through extracting those attribute lines that
		       have errors that have been re-routed */

		    if( baseModNodep != NULLMOD )
			setUpTheAttrLineErrorMsgsAndRouteConfigErrors( operationalMode, OFD, currRAAp, dserrorp ) ;

		    if( anyAttrsStillToBeProcessed( *baseALpp ) == FALSE )
		    {
	    	    	allAttrsProcessed = TRUE ;
		    }
		    else if( anyUnprocessedAttrsWithErrors( currRAAp ) == TRUE )
		    {
		    	if( operationalMode == NON_INTERACT_OPER_MODE )
		    	{
		    	    transferRDNattrs( OFD, OUTPUTPROBLEMFILE, *baseALpp, "Errors require interactive processing",
	 					currRAAp -> attrSequenceErrorMsgcp ) ;
	    	    	    allAttrsProcessed = TRUE ;
	    	    	}
		        else
		     	{
		    	    allAttrsProcessed = editAttributeSequence( inFileType, OFD, entryRDN, currRAAp ) ;

		    	    if( allAttrsProcessed == FALSE )
		    	        setUpTheMasterAttrLineDetails( baseDataSourceLevelp, *baseALpp, sourceNamecp ) ;
		    	}
		    }
		    /* else loop around again to form another modification request */

	    	    /* Note: ds_error_free() called within setUpTheAttrLineErrorMsgsAndRouteConfigErrors()
		       due to its presence within ds_error() as called by error2pstr() */
	        }
	    	else
	    	{
		    if( bulkLoadConfig.disableBulkAttributeUsage == FALSE )
			addOrRemoveNonMasterUpAtValues( entryDN,
				nonMasterUpAttrAVSfromEntry, reqNonMasterUpAttrAVSfromEntry ) ;

		    transferRDNattrs( OFD, OUTPUTDONEFILE, *baseALpp, NULLCP, NULLCP ) ;
		
	    	    allAttrsProcessed = TRUE ;
		}
	    }


	    if( baseModNodep != NULLMOD )
	    {
	    	free_attr_mod_list( baseModNodep ) ;
		baseModNodep = NULLMOD ;
	    }
	    
	    if( reqNonMasterUpAttrAVSfromEntry != NULLAV )
	    {
	    	avs_free( reqNonMasterUpAttrAVSfromEntry ) ;
                reqNonMasterUpAttrAVSfromEntry = NULLAV ;
	    }

	    if( reqOtherAttrsASfromEntry != NULLATTR )
	    {
	    	as_free( reqOtherAttrsASfromEntry ) ;
		reqOtherAttrsASfromEntry = NULLATTR ;
	    }

	} /* main while loop */


	/* Finally return storage.. */

	if( nonMasterUpAttrAVSfromEntry != NULLAV )
	    avs_free( nonMasterUpAttrAVSfromEntry ) ;

	if( objClsAVSfromEntry != NULLAV )
	    avs_free( objClsAVSfromEntry ) ;

	if( aclAVSfromEntry != NULLAV )
	    avs_free( aclAVSfromEntry ) ;

	if( otherAttrsASfromEntry != NULLATTR )
	    as_free( otherAttrsASfromEntry ) ;
	
	return ;
}

/*
 * If the auto object class insertion requirements are fulfilled insert the object classes
 * in the attibute sequence list and into the attribute line list (in case an edit is required.)
 */

void
addAutoInsertObjectClasses( inFileType, currRAAp, baseas )
int	inFileType ;
struct 	rootedAtAttributes * currRAAp ;
Attr_Sequence	baseas ;
{
struct	autoInsertNode * currAutoInsertNodep = bulkLoadConfig.autoInsertNodep ;
struct	autoInsertObjClsListNode * currAutoInsertObjClsListNodep ;
struct 	attributeLine * currALp, * currObjClsALp=NULLALP, *nextALp ; /* Attribute lines are already ordered by AttributeType */
Attr_Sequence	objClsas  = NULLATTR, savedattr_link, autoAttrTas ;
AV_Sequence	objClsavs = NULLAV ;
static	AttributeType	objClsat = NULLAttrT ;
int	objClsALpPresent = FALSE, avAlreadyListed = FALSE ;
char	leadingChar ;

	if( objClsat == NULLAttrT )
	    objClsat =  str2AttrT( BL_OBJECT_CLASS ) ;

	if( currAutoInsertNodep == NULLAUTOINSERTNODE || objClsat == NULLAttrT )
	    return ;

	/* Check for a autoInsertOnAttrT/autoInsertOnAttrV attribute within the attribute sequence.. */

	while( currAutoInsertNodep != NULLAUTOINSERTNODE )
	{
	    /* Find the Attr_Sequence node for the current "autoInsertOnAttrT" (if present) */
	    if( currAutoInsertNodep->autoInsertOnAttrT != NULLAttrT &&
	        (autoAttrTas = findASbyAttrT( baseas, currAutoInsertNodep->autoInsertOnAttrT )) != NULLATTR )
	    {
		/* Check for the required "autoInsertOnAttrV" value.. */
		if( currAutoInsertNodep->autoInsertOnAttrV != NULLAttrV &&
		    findAttrVinAVS( autoAttrTas->attr_value, currAutoInsertNodep->autoInsertOnAttrV ) != NULLAttrV )
		{
		    if( objClsALpPresent == FALSE )
		    {
			/* Find the first existing object class attribute line (if any).. */
			currALp = currRAAp -> attrLinep ;

			while( currALp != NULLALP )
			{
			    currObjClsALp = currALp ; /* currObjClsALp will point to the last ALp if
			    				 no object class nodes can be found */

			    if( AttrT_cmp( currALp -> at, objClsat ) == 0 )
			    {
			    	objClsALpPresent = TRUE ;
				break ;
			    }
	    
			    currALp = currALp -> nextAttrLinep ;
			}
		    }

		    if( objClsas == NULLATTR )
			objClsas =  findASbyAttrT( baseas, objClsat ) ;
		    
		    /* 
		     * Insert the corresponding object classes (if missing)..
		     */

		    currAutoInsertObjClsListNodep = currAutoInsertNodep->autoInsertObjClsListp ;

		    while( currAutoInsertObjClsListNodep != NULLAUTOINSERTOBJCLSLIST )
		    {
		    	if( currAutoInsertObjClsListNodep->autoInsertObjClsAttrV != NULLAttrV )
			{
			    /* Note: we want to add to the AttributeValue to the parameter Attr_Sequence,
			       but must also add a new line to the attribute line list in case a DAP
			       error occurs which requires an edit */

			    avAlreadyListed = FALSE ;

			    if( objClsas == NULLATTR )
			    {
			    	/* Create an Attr_Sequence node for the 1st of the object class attributes to be added.. */

			    	if( (objClsavs = avs_comp_new( AttrV_cpy( currAutoInsertObjClsListNodep->autoInsertObjClsAttrV ))) != NULLAV )
			    	{
			    	    if( (objClsas = as_comp_new( objClsat, objClsavs, NULLACL_INFO )) != NULLATTR )
				    {
				    	/* Link in the node to the current attribute sequence list.. */
				    	savedattr_link 	    = baseas->attr_link ;
				    	baseas->attr_link   = objClsas ;
				    	objClsas->attr_link = savedattr_link ;
				    }
			    	}
			    }
			    else if( insertAVintoAVS( &(objClsas->attr_value), currAutoInsertObjClsListNodep->autoInsertObjClsAttrV ) == TRUE )
			    {
			    	/* AttributeValue is already listed ! */
			    	avAlreadyListed =  TRUE ;
			    }

			    if( avAlreadyListed == FALSE )
			    {
			    	/* Insert the object class as an attribute line.. */
				
			    	if( inFileType == DMFORMATFILEINPUT )
			    	    leadingChar = '\0' ;
			    	else 
			    	    leadingChar = (objClsALpPresent == FALSE) ? ADDATTRCHAR : ADDVALUECHAR ;
				
			    	nextALp = currObjClsALp -> nextAttrLinep ;

			    	if( (currObjClsALp -> nextAttrLinep = (struct attributeLine *)create_lone_attributeLine_node( 
			    		leadingChar, objClsat, currAutoInsertObjClsListNodep->autoInsertObjClsAttrV )) != NULLALP )
			    	{
			    	    currObjClsALp =  currObjClsALp -> nextAttrLinep ;
				    currObjClsALp -> nextAttrLinep =  nextALp ;
				    objClsALpPresent = TRUE ;
			    	}
			    }
			}

			currAutoInsertObjClsListNodep = currAutoInsertObjClsListNodep->nextAutoInsertObjClsListNodep ;
		    }
		}
	    }

	    currAutoInsertNodep = currAutoInsertNodep->nextAutoInsertNodep ;
	}
	
	return ;
}


/*
 * Rules:
 *	1) Delete entry only permitted if source if the deleteSource
 *
 * Note: the bulk data details (i.e. the master and delete source information)
 *	 is cached in case the next call requires the same rootedAt dn.
 */

int
updateDirectory( baseRAApp, inFileType, operationalMode, OFD, sourceNamecp, dataSourceEntryDN )
struct 	rootedAtAttributes ** baseRAApp ;
int	inFileType, operationalMode ;
struct	outputFileDetails OFD[] ;
char *	sourceNamecp ;
DN	dataSourceEntryDN ;
{
int	ret_val=OK, res=NOTOK, modRDNres, actionReq, loopExit, procReq, errorClass, errorType, dnCmpRes ;
int	overruled = FALSE, firstIteration = TRUE, updatesToExistingEntries = bulkLoadConfig.updatesToExistingEntries ;
struct	rootedAtAttributes ** currRAApp = baseRAApp, * prevRAAp = NULL ;
Attr_Sequence	as ;
char *	errorMsgcp = NULLCP, diagnostics1[SMALLBUFLEN], diagnostics2[SMALLBUFLEN], *DNcp ;
DN	modEntryDN = NULLDN, dnToCheckBulkDirectoryDetailsAgainst = NULLDN, nextToLastDNcomp ;

static  DN 	prevRootedAtDN  = NULLDN, entryDN = NULLDN ;
static  RDN	prevEntryRDN    = NULLRDN ;
static  struct 	dataSourceLevel * baseDataSourceLevelp = NULLSOURCELEVEL ;
static	DN 	dnForBulkDirectoryDetails = NULLDN ;
static	int	subDirListInitialised = FALSE ;
static	struct	subDirListDetails rootedAtSubDirListDetails ;

#ifdef DEBUG
char * cp ;
#endif

	if( subDirListInitialised == FALSE )
	{
	    initSubDirectoryList( &rootedAtSubDirListDetails ) ;
	    subDirListInitialised = TRUE ;
	}

	/* process the current RDN block for this rootedAt statement.. */
	while( currRAApp && *currRAApp )
	{	    
	    resetprint( "BULKLOAD is currently processing %s\n", (*currRAApp) -> rdnLinecp );

#ifdef DEBUG
fprintf( stderr, "RDN %s", (*currRAApp) -> rdnLinecp ) ;
#endif
	    /* loop until current RDN block has been processed successfully.. */

	    loopExit = FALSE ; res = NOTOK ; firstIteration = TRUE ;

	    while( loopExit == FALSE )
	    {				
		if( loopExit == FALSE )
		{
		    if( determineActionReq( (*currRAApp) -> rdnLinecp, &actionReq, inFileType, TRUE, NULLALP, updatesToExistingEntries ) != OK )
	    	    {
			strcpy( diagnostics1, "Could not determine how to process the RDN line" ) ;
			diagnostics2[ 0 ] = '\0' ;
			
			loopExit = editRAandRDNblock( inFileType, OFD, sourceNamecp,
					currRAApp, prevRAAp, &actionReq, FALSE, FALSE, NULLCP, &overruled, &updatesToExistingEntries, diagnostics1, diagnostics2 ) ;
		    }
		}
		
		if( loopExit == FALSE )
		{
		    dnCmpRes = 0 ;
		
		    if( prevRootedAtDN == NULLDN || prevEntryRDN == NULLRDN ||
			(dnCmpRes = dn_cmp( (*currRAApp) -> rootedAtDN, prevRootedAtDN) ) != 0 ||
			rdn_cmp((*currRAApp) -> rdn, prevEntryRDN ) != 0 ||
			res == NOTOK ||
			(firstIteration == TRUE && rootedAtSubDirListDetails.subDirListUsed != SUBDIRLISTNOTUSED ))
		    {
			overruled = FALSE ;

			if( dnCmpRes != 0 )
			{
		 	    DNcp = dn2pstr( (*currRAApp) -> rootedAtDN ) ;
			    setUpOutFilesRA( OFD, (DNcp != NULLCP) ? DNcp : "INVALID ROOTEDAT DN" ) ;
			    if( DNcp != NULLCP ) free( DNcp ) ;

			    if( prevRootedAtDN != NULLDN ) 
			    	dn_free( prevRootedAtDN ) ;

			    prevRootedAtDN  = dn_cpy(  (*currRAApp) -> rootedAtDN ) ;

			} else if( prevRootedAtDN == NULLDN )
			    prevRootedAtDN = dn_cpy( (*currRAApp) -> rootedAtDN ) ;


			setUpOutFilesRDN( OFD, (*currRAApp) -> rdnLinecp ) ;
		    	
			if( prevEntryRDN != NULLRDN ) 
			    rdn_free( prevEntryRDN ) ;

			prevEntryRDN = rdn_cpy( (*currRAApp) -> rdn ) ;

			if( entryDN != NULLDN )
			{
			    dn_free( entryDN ) ; entryDN = NULLDN ;
			}

			res = determineActualDirectoryEntry( inFileType, operationalMode, OFD, 
					sourceNamecp, currRAApp, prevRAAp, &entryDN, &actionReq, &rootedAtSubDirListDetails, &updatesToExistingEntries ) ;

		    	/* Note: ..may have changed actionReq from ADDRDNACTION to NOACTIONREQ
			   if entry already exists but the attributes are still to be added
			   Also, the rootedAt DN or the entry RDN may have been changed.. */

			if( dn_cmp( (*currRAApp) -> rootedAtDN, prevRootedAtDN ) != 0 )
			{
			    overruled = FALSE ;

		 	    DNcp = dn2pstr( (*currRAApp) -> rootedAtDN ) ;
			    setUpOutFilesRA( OFD, (DNcp != NULLCP) ? DNcp : "INVALID ROOTEDAT DN" ) ;
			    if( DNcp != NULLCP ) free( DNcp ) ;

			    if( prevRootedAtDN != NULLDN ) dn_free( prevRootedAtDN ) ;

			    prevRootedAtDN = dn_cpy(  (*currRAApp) -> rootedAtDN ) ;
			}
			
			if( rdn_cmp((*currRAApp) -> rdn, prevEntryRDN ) != 0 )
			{
			    overruled = FALSE ;

			    setUpOutFilesRDN( OFD, (*currRAApp) -> rdnLinecp ) ;

			    if( prevEntryRDN != NULLRDN )
			    	rdn_free( prevEntryRDN ) ;
			    	
			    prevEntryRDN = rdn_cpy( (*currRAApp) -> rdn ) ;
			}
		    		
			/* Note: the master and create/delete source directory information is retrieved ONCE per entry parent DN.. */

			if( entryDN != NULLDN )
			{
			    if( rootedAtSubDirListDetails.subDirListUsed != SUBDIRLISTNOTUSED &&
				(DNcp = extractParentDNandReturnDNcp( entryDN )) != NULLCP      )
			    {
				setUpOutFilesSubDirListResolvedDN( OFD, DNcp ) ;
			    	free( DNcp ) ;
			    }
			    else setUpOutFilesSubDirListResolvedDN( OFD, NULLCP ) ;

			    dnToCheckBulkDirectoryDetailsAgainst = NULLDN ;

			    if( rootedAtSubDirListDetails.subDirListUsed == SUBDIRLISTNOTUSED )
			    	dnToCheckBulkDirectoryDetailsAgainst = dn_cpy( (*currRAApp) -> rootedAtDN ) ;
			    else
			    {
			    	if( (dnToCheckBulkDirectoryDetailsAgainst = dn_cpy( entryDN )) != NULLDN )
			    	{
			    	    if( (nextToLastDNcomp = findNextToLastDN( dnToCheckBulkDirectoryDetailsAgainst )) != NULLDN )
			    	    {
			    	    	dn_free( nextToLastDNcomp -> dn_parent ) ;
			    	    	nextToLastDNcomp -> dn_parent = NULLDN ;
			    	    }
			    	    else 
			    	    {
			    	    	dn_free( dnToCheckBulkDirectoryDetailsAgainst ) ;
				    	dnToCheckBulkDirectoryDetailsAgainst = NULLDN ;
				    }
			    	}
			    }

			    if( dnToCheckBulkDirectoryDetailsAgainst == NULLDN )
			    {
				transferRootedAtRDNattrs( OFD, OUTPUTPROBLEMFILE, *currRAApp, "Internal malloc failure ", NULLCP ) ;

		    		loopExit = TRUE ;
			    }
			    else if( dnForBulkDirectoryDetails == NULLDN ||
			     	dn_cmp( dnForBulkDirectoryDetails, dnToCheckBulkDirectoryDetailsAgainst ) != 0 )
			    {
			    	if( dnForBulkDirectoryDetails != NULLDN )
				    dn_free( dnForBulkDirectoryDetails ) ;

	  		    	dnForBulkDirectoryDetails = dn_cpy( dnToCheckBulkDirectoryDetailsAgainst ) ;

			    	free_BulkDirectoryDetailspp( &baseDataSourceLevelp ) ;

			    	if( retrieveBulkDirectoryDetails( dnForBulkDirectoryDetails, &baseDataSourceLevelp, dataSourceEntryDN ) != OK )
			    	{
		    		    dn_free( dnForBulkDirectoryDetails ) ; dnForBulkDirectoryDetails = NULLDN ;

				    DNcp = dn2pstr( dnForBulkDirectoryDetails ) ;
				    transferRootedAtRDNattrs( OFD, OUTPUTPROBLEMFILE, *currRAApp, "Could not retrieve the directory bulk details for ", (DNcp != NULLCP) ? DNcp : "UNPRINTABLE DN" ) ;
			    	    if( DNcp != NULLCP ) free( DNcp ) ;

		    		    loopExit = TRUE ;
				}
			    }

			    if( dnToCheckBulkDirectoryDetailsAgainst != NULLDN )
			    	dn_free( dnToCheckBulkDirectoryDetailsAgainst ) ;
			}
		    }
		    else
		    {
		    	if( entryDN != NULLDN )
			{
			    if( rootedAtSubDirListDetails.subDirListUsed != SUBDIRLISTNOTUSED &&
			        (DNcp = extractParentDNandReturnDNcp( entryDN )) != NULLCP      )
			    {
			    	setUpOutFilesSubDirListResolvedDN( OFD, DNcp ) ;
			    	free( DNcp ) ;
			    }
			    else setUpOutFilesSubDirListResolvedDN( OFD, NULLCP ) ;
			}
		    }
#ifdef DEBUG
fprintf( stderr, ">>>>>>Res %d\n", res) ;
#endif
		    if( entryDN == NULLDN )
		    {
			/* any required RDN block transfers will have occurred in determineActualDirectoryEntry() */
			loopExit = TRUE ;
		    }
		    
		    if( loopExit == FALSE )
		    {
			if( actionReq == ADDRDNACTION && res == OK )
			{
			    if( overruled == TRUE ||
			    	sourceIsACreateSource( baseDataSourceLevelp, sourceNamecp, (*currRAApp)->rdn ) == TRUE )
			    {			    
				/* A create entry is required and permitted */

			    	if( (as = formAttrSeqFromRAA( *currRAApp )) != NULLATTR )
			    	{
				    /* Apply the auto insert object classes.. */
				    addAutoInsertObjectClasses( inFileType, *currRAApp, as ) ;
				
			    	    /* No checks on master source since all attributes
				       being added to entry for the first time */

				    if( bulkLoadConfig.disableBulkAttributeUsage == FALSE &&
				    	bulkDataObjClsPresent( as ) == FALSE )
				    {
					/* ..note this check will only pass the first time around as we
					   now add in a bulk object class */
				    
				    	/* Add any required "nonMasterUpdatedAttrType" values */
				    	appendNonMasterUpdatesForNewEntry( baseDataSourceLevelp, sourceNamecp, &as ) ;

				    	if( findAttrTypecpRdnComp( BL_DATA_SOURCE, (*currRAApp) -> rdn ) != NULLRDN )
				    	{
				    	    appendAttributeToAttrSeq( BL_OBJECT_CLASS, BL_BULK_DATA_SOURCE_DETAILS, as ) ;
				    	}
				    	else if( findAttrTypecpRdnComp( BL_BULK_SUB_DIR_LIST, (*currRAApp) -> rdn ) != NULLRDN )
				    	{
				    	    appendAttributeToAttrSeq( BL_OBJECT_CLASS, BL_BULK_SUB_DIR_LIST_CLASS, as ) ;
				    	}
				    	else
				    	{
				    	    /* If we are creating an entry then add an algoName and bulk data entry object class attributes.. */
				    	    appendAttributeToAttrSeq( BL_OBJECT_CLASS, BL_BULK_DATA_ENTRY_DETAILS, as ) ;

				    	    appendAlgoNameAttributeToAttrSeq( (*currRAApp) -> rdn, rootedAtSubDirListDetails.subDirListRDN, sourceNamecp, as ) ;

				    	    appendDeleteEntryAfterToAttrSeq( as ) ;
				        }
				    }
				    
				    if( AddEntry( entryDN, as, &errorMsgcp, &errorClass, &errorType ) == NOTOK )
				    {

				    	if( errorClass == DSE_UPDATEERROR && errorType == DSE_UP_OBJECTCLASSVIOLATION )
					    strcpy( diagnostics1, "Add entry failure due to class violation - check your dsap.log file" ) ;
				    	else
					    strcpy( diagnostics1, "Add entry failure" ) ;
#ifdef DEBUG				    
fprintf( stderr, "Add failure %s\n", errorMsgcp ) ;
#endif
				    	if( operationalMode == NON_INTERACT_OPER_MODE )
				    	{
				    	    transferRDNattrs( OFD, OUTPUTPROBLEMFILE, (*currRAApp)->attrLinep, diagnostics1, errorMsgcp ) ;
					    loopExit = TRUE ;
				    	}
				    	else loopExit = editRAandRDNblock( inFileType, OFD, sourceNamecp,
							    currRAApp, prevRAAp, &actionReq, FALSE, FALSE, NULLCP, &overruled, &updatesToExistingEntries, diagnostics1, errorMsgcp) ;

				    	free( errorMsgcp ) ;
				    }
				    else 
				    {
					overruled = FALSE ;
				    	transferRDNattrs( OFD, OUTPUTDONEFILE, (*currRAApp)->attrLinep, NULLCP, NULLCP ) ;
				    	loopExit = TRUE ;				    
				    }
				    
			    	    as_free( as ) ;
			    	}
			    	else
			    	{
				    transferRDNattrs( OFD, OUTPUTPROBLEMFILE, (*currRAApp)->attrLinep, "Could not form attribute sequence when Adding the new entry", NULLCP ) ;
				    loopExit = TRUE ;				    
				}
			    }
			    else
			    {
				strcpy( diagnostics1, "Create entry failure since not a create source" ) ;
				diagnostics2[ 0 ] = '\0' ;

				procReq = bulkLoadConfig.configErrorProcReq[ CREATEENTRYWHENNOTCREATESOURCE ] ;

				if( operationalMode == NON_INTERACT_OPER_MODE && procReq == PROCESSTHEUPDATE )
				    procReq =  OUTPUTPROBLEMFILE ;

				if( procReq != PROCESSTHEUPDATE )
				{
				    transferRDNattrs( OFD, procReq, (*currRAApp)->attrLinep, diagnostics1, diagnostics2 ) ;
				    loopExit = TRUE ;
				}
				else loopExit = editRAandRDNblock( inFileType, OFD, sourceNamecp,
							    currRAApp, prevRAAp, &actionReq, FALSE, TRUE, "the create or delete source specification", &overruled, &updatesToExistingEntries, diagnostics1, diagnostics2 ) ;
			    }				
			}
			else if( actionReq == DELETERDNACTION )
		    	{
			    if( overruled == TRUE ||
			    	sourceIsADeleteSource( baseDataSourceLevelp, sourceNamecp ) == TRUE )
			    {			    
				if( RemoveEntry( entryDN, &errorMsgcp ) == NOTOK )
				{
#ifdef DEBUG
fprintf( stderr, "Remove failure %s\n", errorMsgcp ) ;
#endif
				    strcpy( diagnostics1, "Remove entry failure" ) ;

				    if( operationalMode == NON_INTERACT_OPER_MODE )
				    {
				    	transferRDNattrs( OFD, OUTPUTPROBLEMFILE, (*currRAApp)->attrLinep, diagnostics1, errorMsgcp ) ;
					loopExit = TRUE ;
				    }
				    else loopExit = editRAandRDNblock( inFileType, OFD, sourceNamecp,
							    currRAApp, prevRAAp, &actionReq, FALSE, FALSE, NULLCP, &overruled, &updatesToExistingEntries, diagnostics1, errorMsgcp) ;

				    free( errorMsgcp ) ;
				}
				else
				{	
				    overruled = FALSE ;
				    transferRDNattrs( OFD, OUTPUTDONEFILE, (*currRAApp)->attrLinep, NULLCP, NULLCP ) ;
				    loopExit = TRUE ;
				}
			    }
			    else 
			    {
				strcpy( diagnostics1, "Delete entry failure since not a delete source" ) ;
				diagnostics2[ 0 ] = '\0' ;

				procReq = bulkLoadConfig.configErrorProcReq[ DELETEENTRYWHENNOTDELETESOURCE ] ;

				if( operationalMode == NON_INTERACT_OPER_MODE && procReq == PROCESSTHEUPDATE )
				    procReq =  OUTPUTPROBLEMFILE ;

				if( procReq != PROCESSTHEUPDATE )
				{
				    transferRDNattrs( OFD, procReq, (*currRAApp)->attrLinep, diagnostics1, diagnostics2 ) ;
				    loopExit = TRUE ;
				}
				else loopExit = editRAandRDNblock( inFileType, OFD, sourceNamecp,
							    currRAApp, prevRAAp, &actionReq, FALSE, TRUE, "the create or delete source specification", &overruled, &updatesToExistingEntries, diagnostics1, diagnostics2 ) ;
			    }				
			}
			else
		    	{
			    /*
			     * Now Check for the presence of an rdn modification request
			     */
			     
	    	    	    if( (*currRAApp) -> modRdn != NULLRDN )
			    {
				actionReq = MODRDNACTION ;
			    
				/*
				 * Will need to check new RDN does not clash as per entryDN
				 */
				     

			 	/* Evaluate the acceptability of the replacement RDN.. */

				modEntryDN = NULLDN ;

		    		modRDNres = determineActualDirectoryEntry( inFileType, operationalMode, OFD, 
							sourceNamecp, currRAApp, prevRAAp, &modEntryDN, &actionReq, &rootedAtSubDirListDetails, &updatesToExistingEntries ) ;
				    
				if( modEntryDN != NULLDN && modRDNres == OK )
				{
#ifdef DEBUG				    
cp = dn2pstr( entryDN ) ;
fprintf( stderr, "mod rdn entryDN was %s\n", cp ) ;
free(cp) ;
cp = dn2pstr( modEntryDN ) ;
fprintf( stderr, "mod rdn modEntryDN was %s\n", cp ) ;
free(cp) ;
cp = rdn2pstr( (*currRAApp) -> modRdn ) ;
fprintf( stderr, "mod rdn was %s\n", cp ) ;
free(cp) ;
#endif
				    if( ModifyRdn( entryDN, (*currRAApp) -> modRdn, TRUE, &errorMsgcp ) == NOTOK )
				    {
					/* ...specifies deletion of old RDN attributes */
				    
					strcpy( diagnostics1, "Modify RDN failure" ) ;

					if( operationalMode == NON_INTERACT_OPER_MODE )
					{
					    transferRootedAtModRDN( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, errorMsgcp ) ;
					    loopExit = TRUE ;
				    	}
				    	else loopExit = editRAandRDNblock( inFileType, OFD, sourceNamecp,
								    currRAApp, prevRAAp, &actionReq, FALSE, FALSE, NULLCP, &overruled, &updatesToExistingEntries, diagnostics1, errorMsgcp) ;

					diagnostics1[ 0 ] = '\0' ;
				    	free( errorMsgcp ) ;
				    }
				    else 
				    {
					/* modifyRDN was successful so now update the "algoName" attribute.. */

					replaceAlgoName( modEntryDN, (*currRAApp) -> modRdn, (*currRAApp) -> rdn, rootedAtSubDirListDetails.subDirListRDN, sourceNamecp ) ;

					transferRootedAtModRDN( OFD, OUTPUTDONEFILE, *currRAApp, NULLCP, NULLCP ) ;

					loopExit = TRUE ;				    

					/* Now assign the modified RDN's DN to the entry's DN */
					dn_free( entryDN ) ;
					entryDN    = modEntryDN ;
					modEntryDN = NULLDN ;
					
					if( prevEntryRDN != NULLRDN ) 
					{
					    rdn_free( prevEntryRDN ) ;
					    prevEntryRDN = NULLRDN ;
					}
				    }

				    if( modEntryDN != NULLDN )
					dn_free( modEntryDN ) ;
				}
				else {

				    /* Even though the modified DN was in some way unacceptable it
				       may well be the case that an RDN modification request has already
				       been applied so we just need to modify the algoName attribute
				       for the specified source.. */
				    if( modEntryDN != NULLDN )
					dn_free( modEntryDN ) ;

				    modEntryDN = dn_cpy( entryDN ) ;

				    if( modEntryDN != NULLDN ) {
					replaceAlgoName( modEntryDN, (*currRAApp) -> modRdn, (*currRAApp) -> rdn, rootedAtSubDirListDetails.subDirListRDN, sourceNamecp ) ;

					dn_free( modEntryDN ) ;
					modEntryDN = NULLDN ;
				    }

				    loopExit = TRUE ;
				}

			    }  /* RDN modification */
			    else
			    {
				/* Attribute updates */
#ifdef DEBUG				    
cp = dn2pstr( entryDN ) ;
fprintf( stderr, "entryDN is now %s\n", cp ) ;
free(cp) ;
#endif
			    	updateAttribute( operationalMode, *currRAApp, sourceNamecp,
						entryDN, baseDataSourceLevelp, OFD, inFileType ) ;

				loopExit = TRUE ;
				
			    }

			} /* Not Add or Delete RDN entry */

		    } /* resolved entry DN valid */
		}

		firstIteration = FALSE ;

	    } /* ..while loop - until current RDN block has been processed successfully */

	    prevRAAp  = *currRAApp ;
	    currRAApp = &((*currRAApp) -> nextRootedAtAttrsp) ;

	} /* ..while loop - process rootedAt rdn blocks  */

        /* Note: the bulk data source details will be available
	   for the next call as we are not freeing them here    */
	    
	return( ret_val ) ;

} /* updateDirectory() */
